
/************************* Agilent_34401A_GPIB_12 *******************************

  There are more than one Agilent 34401A devices in this test fixture.  This 
is the reasoning for the suxfix Agilent_34401A_DMM_xx where "xx" equals 0,1,.N



********************************************************************************/



#ifndef  _Agilent_34401A_GPIB_12_dot_h_
#define  _Agilent_34401A_GPIB_12_dot_h_


/******************  COMPILER strcpy_s appeasement ********************
  Need to use a # define to appease  strcpy_s
******************  ___________________ ****************************/
#ifndef   define_256_chars  
#define   define_256_chars  (256)
#endif 





VISA_GPIB_Manager Agilent_34401A_GPIB_12_HW_conduit;

#include "VISA_GPIB_Manager.h"


int  Agilent_34401A_Transmitt_Message_GPIB_12(char Interface_Message[], int &number_of_chars);//Only conduit to machine
int  Agilent_34401A_Receive_Message_GPIB_12  (char Interface_Message[], int &number_of_chars);//Only conduit from machine
int  Agilent_34401A_Init_GPIB_12(void);



//****************** UNIQUE HARDWARE INTERFACE OBJECTS ********************** 
int  Agilent_34401A_GPIB_Device_ID_GPIB_12;//USED BY NI488 to ID Agilent meter SEE int Agilent_34401A_Init_GPIB_12(void)




double long Agilent_34401A_Fetch_DUT_DC_CURRENT_GPIB_12();
double long Agilent_34401A_Fetch_DUT_DC_Voltage_GPIB_12();

double long Agilent_34401A_Fetch_DUT_AC_CURRENT_GPIB_12();
double long Agilent_34401A_Fetch_DUT_AC_Voltage_GPIB_12();


/********************** Agilent_34401A_Transmitt_Message_GPIB_12 ************************
  
   This funcion is the only conduit to the equipment.  You place what ever 
SCPI code that you want in the "char Interface_Message[]" 

  This simplifies the hardware interface in the sense that you only need to place
 hardware IO code in one place.  

  @params
  char Interface_Message[] This MUST be a NULL terminated message that 
you pass to the equipment.

  @returns 

  the return message depends on the I/O software that you  use.  I have no way
  a priori to know this.

******************************************************************************/


int Agilent_34401A_Transmitt_Message_GPIB_12(char Interface_Message[], int &number_of_chars)
{
   int Error_Message=0;// Only feedback mechanism 

  unsigned long  Actual_Write_Count;

   Actual_Write_Count = 0 ;//FOCED INIT
   Agilent_34401A_GPIB_12_HW_conduit.Transmitt_a_char_array_to_GPIB(Interface_Message,number_of_chars,Actual_Write_Count);

   number_of_chars=(int)Actual_Write_Count;

   //************* UNIQUE CLIENT HARDWARE CODE ABOVE HERE ***************
  return Error_Message;
}




/************** Agilent_34401A_Receive_Message_GPIB_12  *****************

  This funcion is the only conduit from the equipment.  
  
    
	This simplifies the hardware interface in the sense that you only need 
to place IO hardware code in one place.  

  @params
  char Interface_Message[] Thisis  a NULL terminated message that 
you receive from the equipment.

  @returns 

  The return message depends on the I/O software that you  use.  I have no way
  a priori to know this.


************************************************************************/





int Agilent_34401A_Receive_Message_GPIB_12  (char Interface_Message[], int &number_of_chars)
{
  int Error_Message=0;// Only feedback mechanism 

  unsigned long Bytes_in_GPIB_conduit;


  Bytes_in_GPIB_conduit =(unsigned long )number_of_chars;
  Agilent_34401A_GPIB_12_HW_conduit.Receive_a_char_array_from_GPIB(Interface_Message,Bytes_in_GPIB_conduit);

  number_of_chars=(int)Bytes_in_GPIB_conduit;



  return Error_Message;
}




/*************************  Agilent_34401A_Init_GPIB_12 ****************************

 This is a collection of functions that you use to initialise the  hardware 
 
    
	   >>>>>AND<<<<<< 
	   
		
the software interface software. Examples of this are GPIB settings or RS232
settings, file pointers ect.

@returns 

  The return message depends on the I/O software that you  use.  I have no way
  a priori to know this.


**********************************************************************/
int Agilent_34401A_Init_GPIB_12(void)
{
  int Error_Message=0;// Only feedback mechanism 
  int Number_of_chars;

  char Interface_Message[define_256_chars];//Message sent to Agilent


  Agilent_34401A_GPIB_12_HW_conduit.Detect_Avalible_VISA_Interfaces();
  //************* UNIQUE CLIENT HARDWARE CODE BELOW HERE ***************
  Agilent_34401A_GPIB_12_HW_conduit.Designate_GPIB_Address("GPIB0::12::INSTR");
 
  //************* UNIQUE CLIENT HARDWARE CODE ABOVE HERE ***************


   strcpy_s(Interface_Message,define_256_chars,"*RST");//Query macine for ID
   Number_of_chars=strlen(Interface_Message);
   Agilent_34401A_Transmitt_Message_GPIB_12(Interface_Message,Number_of_chars);

    strcpy_s(Interface_Message,define_256_chars,"*CLS");//Query macine for ID
   Number_of_chars=strlen(Interface_Message);
   Agilent_34401A_Transmitt_Message_GPIB_12(Interface_Message,Number_of_chars);


   //**************** SANITY CHECK ON MACHINE INIT ****************
   strcpy_s(Interface_Message,define_256_chars,"*IDN?");//Query macine for ID
   Number_of_chars=strlen(Interface_Message);
   Agilent_34401A_Transmitt_Message_GPIB_12(Interface_Message,Number_of_chars);


	Number_of_chars = 500;
    Agilent_34401A_Receive_Message_GPIB_12  (Interface_Message,Number_of_chars);
	Interface_Message[Number_of_chars]='\0';
	printf("GPIB_12 Init Message =%s\n",Interface_Message);

 


  

     // visual sanity check on  machine
	 strcpy_s(Interface_Message,define_256_chars,"DISPLAY:TEXT 'GPIB_12_OK'");//Query macine for ID
     Number_of_chars=strlen(Interface_Message);
     Agilent_34401A_Transmitt_Message_GPIB_12(Interface_Message,Number_of_chars);

		


  return Error_Message;

};//END int Agilent_34401A_Init_GPIB_12(void)





/******************** Agilent_34401A_Fetch_DUT_DC_CURRENT_GPIB_12 **************************
  
    I want to configure the Agilent meter to measure 20mA with as much precision
as possible.  

 I need to instruct the meter to use as high as precision as possible. 

   Use the phrase "MEASure:CURRent:DC? 0.100, 0.0000001"  the last term adjusts
 the precision.  I have forgotten what this means. The smaller the number,
 the higher the precision.  The meter also requires longer time If you want an
 explanation,then consult the Agilent literature that I have furnished with 
 this program.


 ********************_________________________________ **************************/

 double long Agilent_34401A_Fetch_DUT_DC_CURRENT_GPIB_12()
 {

  double long Measured_DUT_current;


  char Interface_Message[define_256_chars];
  int Number_of_chars;
   

   //****** EXTRACT MEASUREMENT ************************
 





	strcpy_s(Interface_Message,define_256_chars,"MEASure:CURRent:DC? 0.100, MIN");//Query macine for ID MIN
    Number_of_chars=strlen(Interface_Message);
    Agilent_34401A_Transmitt_Message_GPIB_12(Interface_Message,Number_of_chars);


   Number_of_chars =500;
   Agilent_34401A_Receive_Message_GPIB_12  (Interface_Message,Number_of_chars);
   Interface_Message[Number_of_chars]='\0';

   


    Measured_DUT_current=Array_to_Double (Interface_Message );
 
  return  Measured_DUT_current;
 };//END  double long Agilent_34401A_Fetch_DUT_DC_CURRENT_GPIB_12()








/******************** Agilent_34401A_Fetch_DUT_AC_CURRENT_GPIB_12 **************************
  
  This is a perfideous measurement!! You can NOT reset (*RST) the machine just prior
 to  requesting this measurement.  If you observe abnormally high reported AC current 
 measurements, then search through your code for a reset or a change of configuration.


 ********************_________________________________ **************************/

 double long Agilent_34401A_Fetch_DUT_AC_CURRENT_GPIB_12()
 {

  double long Measured_DUT_current;


  char Interface_Message[define_256_chars];
  int Number_of_chars;
   

   //****** EXTRACT MEASUREMENT ************************
   
   // Instruct the Agilent to ignore other request while
   // measuring the current.  THis measurement requires 
   // 3 to 4 seconds.


    strcpy_s(Interface_Message,define_256_chars,"*WAI");//Query macine for ID
    Number_of_chars=strlen(Interface_Message);
    Agilent_34401A_Transmitt_Message_GPIB_12(Interface_Message,Number_of_chars);

   // Actual request


    strcpy_s(Interface_Message,define_256_chars,"MEAS:CURR:AC? 0.1,1E-6");//Query macine for ID
    Number_of_chars=strlen(Interface_Message);
    Agilent_34401A_Transmitt_Message_GPIB_12(Interface_Message,Number_of_chars);
  
  

	  Number_of_chars =500;
   Agilent_34401A_Receive_Message_GPIB_12  (Interface_Message,Number_of_chars);
   Interface_Message[Number_of_chars]='\0';


   


    Measured_DUT_current=Array_to_Double (Interface_Message );
 
  return  Measured_DUT_current;
 };//END  double long Agilent_34401A_Fetch_DUT_ADC_CURRENT()












/******************** Agilent_34401A_Fetch_DUT_DC_Voltage_GPIB_12 **************************
  
    I want to configure the Agilent meter to measure 0 to 10V with as much precision
as possible.  

   I have forgotten what this means.  If you want an explanation,
 then consult the Agilent literature that I have furnished with this program.


 ********************_________________________________ **************************/

 double long Agilent_34401A_Fetch_DUT_DC_Voltage_GPIB_12()
 {

  double long Measured_DUT_voltage;


  char Interface_Message[define_256_chars];
 
    int Number_of_chars;

   //****** EXTRACT MEASUREMENT ************************

	strcpy_s(Interface_Message,define_256_chars,"VOLTage:DC:NPLC 10");//
    Number_of_chars=strlen(Interface_Message);
    Agilent_34401A_Transmitt_Message_GPIB_12(Interface_Message,Number_of_chars);
   
	


    strcpy_s(Interface_Message,define_256_chars,"MEASure:VOLT:DC? 10");//
    Number_of_chars=strlen(Interface_Message);
    Agilent_34401A_Transmitt_Message_GPIB_12(Interface_Message,Number_of_chars);

	Number_of_chars =500;
   Agilent_34401A_Receive_Message_GPIB_12  (Interface_Message,Number_of_chars);
   Interface_Message[Number_of_chars]='\0';

   //printf("Interface_Message=%s\n",Interface_Message);


   Measured_DUT_voltage=Array_to_Double (Interface_Message );





 
  return  Measured_DUT_voltage;
 };//END  double long Agilent_34401A_Fetch_DUT_DC_Voltage_GPIB_12()





/******************** Agilent_34401A_Fetch_DUT_AC_Voltage_GPIB_12 **************************
  
    I want to configure the Agilent meter to measure AC voltage.  This is done 
    as a simple check for DUT oscillation.  This is a crude test. Snivel, Snivel.

 ********************_________________________________ **************************/

 double long Agilent_34401A_Fetch_DUT_AC_Voltage_GPIB_12()
 {

  double long Measured_DUT_voltage;
  int         Number_of_chars;

  char        Interface_Message[define_256_chars];
 
   

   //****** EXTRACT MEASUREMENT ************************

    strcpy_s(Interface_Message,define_256_chars,"MEASure:VOLT:AC? 10, 0.00001");//Query macine for ID
    Number_of_chars=strlen(Interface_Message);
    Agilent_34401A_Transmitt_Message_GPIB_12(Interface_Message,Number_of_chars);


    Number_of_chars =500;
   Agilent_34401A_Receive_Message_GPIB_12  (Interface_Message,Number_of_chars);
   Interface_Message[Number_of_chars]='\0';


   Measured_DUT_voltage=Array_to_Double (Interface_Message );
 
  return  Measured_DUT_voltage;
 };//END  double long Agilent_34401A_Fetch_DUT_DC_Voltage_GPIB_12()







#endif