

#ifndef _Configurable_8_or_16_bit_CRC_dot_h_
#define _Configurable_8_or_16_bit_CRC_dot_h_


#pragma message("\n ************* ------------------------- ***********************  \n")
#pragma message("\n **      _Configurable_8_or_16_bit_CRC_dot_h_                  *  \n")
#pragma message("\n **               January  03, 2019                            *  \n")
#pragma message("\n ************* _________________________ ***********************  \n \n \n")


/************************************************************************
   Tke following is code that allows you to configure a cyclic redundancy 
check  based on the the following three parameters.

1) A CRC polynomial. 

2) An initial register state for all of the flip flops

3) Number of bits




Two specific polynomials are discussed below:

 1) MODBUS POLYNOMIAL 

 2) Maxim Semiconductor's CRC for use with one wire devices 


THere are several references at the bottom of this file.



 MODBUS POLYNOMIAL 


    The MODBUS CRC polynomial (Polynomial_CONFIG_WORD)  describes how the
	CRC is calculated.  Find a circuit diagram for a MODBUS CRC.

	Registers 15,2,and 1 have an XOR gate attached to their outputs. The 
	input also has an XOR gate.

    Polynomial_CONFIG_WORD= (X^16)+(X^15)+(X^2)+(X^0); 
  
     The highest value ("16") is is the input XOR gate so you can 
    ignore it during polynomial configuration calculations.

	 Polynomial_CONFIG_WORD = 2^15+ 2^2 + 2^0 = 0X8005;


 MODBUS INITAL STATE


    The initial state of the MODBUS registers is all high.
  
	

Need to change the configuration parameters:



 		
  //MODBUS configuration See NOTES above
   Number_of_bits_in_CRC   =16;
   Polynomial_CONFIG_WORD  =0X8005;
   Register_Initilisations =0XFFFF;




EXAMPLE DATA:

 PAGE 2, of reference #2(References listed below)

"Sent to Write (16-bit) Set Point of 1,250 F" 


unsigned char   MODBUS_byte_array[0XFFFFF];
int             Input_number_of_bytes;
unsigned short Expected_CRC;


		MODBUS_byte_array[0]=0X01;//INPUT DATA
		MODBUS_byte_array[1]=0X06;//INPUT DATA

		MODBUS_byte_array[2]=0X01;//INPUT DATA
		MODBUS_byte_array[3]=0X2C;//INPUT DATA

		MODBUS_byte_array[4]=0X04;//INPUT DATA
		MODBUS_byte_array[5]=0XE2;//INPUT DATA

		MODBUS_byte_array[6]=0XCB;// LOW BYTE OF CRC
		MODBUS_byte_array[7]=0X76;// HIGH BYTE CRC


		Input_number_of_bytes=6;


 Expected_CRC=MODBUS_16bit_CRC(MODBUS_byte_array, Input_number_of_bytes);

 //  Expected_CRC should equal 0X76CB







 MAXIM Semiconductors Application Note 27 Example  



   The " Polynomial_CONFIG_WORD"  describes how the CRC is calculated.
For example, if 

CRC_Polynomial=(X^8) + (X^5) +(X^4)+1; 

  _____________  EQUALS  ___________

CRC_Polynomial=(X^8) + (X^5) +(X^4)+(X^0); 

  
The constant "8" is the highest bit. 

The highest bit is calculated automatically here so you can ignore it.


  "Polynomial_CONFIG_WORD" would be: 
 
  Polynomial_CONFIG_WORD = 2^5+ 2^4 + 2^0;

  Polynomial_CONFIG_WORD = 32 + 16 + 1;

  Polynomial_CONFIG_WORD = 49 ;//(0X31)


  The initial state of the registers are: 0X0000;

  There are 8 bits.
  

Need to change the configuration parameters:


   Number_of_bits_in_CRC   =8;
   Polynomial_CONFIG_WORD  =0X31;
   Register_Initilisations =0X00;



Example PACKET from Maxim application note 27:


Input_CRC_data_array[0]=0X02;
Input_CRC_data_array[1]=0X1C;
Input_CRC_data_array[2]=0XB8;
Input_CRC_data_array[3]=0X01;
Input_CRC_data_array[4]=0X00;
Input_CRC_data_array[5]=0X00;
Input_CRC_data_array[6]=0X00;



Expected results from above data:CRC =0XA2



************************************************************************/







/************************** MODBUS_16bit_CRC ****************************

Entity ID                 Translation:

"Input_CRC_data_array"   This is an array of unsigned chars.  
                         This is the stream of data that you want the 
						 CRC for.


"Input_number_of_bytes"   This is the number of bytes in the 
                          aforementioned "Input_CRC_data_array"


returned value:          unsigned short (byte) that is your 16 bit CRC
                        Format:

						  0X(HIGH_byte)(Low_Byte)


************************  _________________ ***************************/




unsigned short Configurable_8_or_16_bit_CRC(unsigned char Input_CRC_data_array[], unsigned int Input_number_of_bytes);

unsigned short Configurable_8_or_16_bit_CRC(unsigned char Input_CRC_data_array[], unsigned int Input_number_of_bytes)
{  

  unsigned short calculated_CRC_16bit;
  unsigned short REVERSED_CRC_Polynomial;
  unsigned short Polynomial_CONFIG_WORD;
  unsigned short Bit_Mask;
  unsigned short Number_of_bits_in_CRC;
  unsigned short Register_Initilisations;


  unsigned char  bit_index;
  unsigned char  Number_of_bytes_in_reply;


  unsigned int   byte_index;


//  unsigned int Number_of_required_bytes_for_CRC;
 
		
		
   //MODBUS configuration See NOTES above
   Number_of_bits_in_CRC   =16;
   Polynomial_CONFIG_WORD  =0X8005;
   Register_Initilisations =0XFFFF;





   //MAXIM AN 27 CRC configuration See NOTES above
   //Number_of_bits_in_CRC   =8;
   //Polynomial_CONFIG_WORD  =0X31;
   //Register_Initilisations =0X00FF;

   


   
   Number_of_bits_in_CRC   =8;
   Polynomial_CONFIG_WORD  =0X31;
   Register_Initilisations =0X00FF;

   //fprintf(stderr,"Polynomial_CONFIG_WORD (gb) =0X%X\n",Polynomial_CONFIG_WORD);
   //fprintf(stderr,"Register_Initilisations =0X%X\n",Register_Initilisations);
               
   //getchar();



 
   Number_of_bytes_in_reply =0X00;


    if (8==Number_of_bits_in_CRC )
    {
      Number_of_bytes_in_reply =0X01;   
    }

  
    if (16==Number_of_bits_in_CRC )
    {
     Number_of_bytes_in_reply =0X02;
 
    }


	if (0X00==Number_of_bytes_in_reply)
	{
	   system("cls");
	   fprintf(stderr,"*************** FUABR ALERT*******************\n");
	   fprintf(stderr,"*                                            *\n");
	   fprintf(stderr,"*   Number of bits in CRC MUST be 8 -or- 16  *\n");
	   fprintf(stderr,"*                                            *\n");
	   fprintf(stderr,"*************** ____________******************\n\n\n\n\n\n");
	   fprintf(stderr,"Tap any key to exit.........");
	   getchar();
	return 0XFFFF;
	}
   

   // Code below requires a reversed CRC polynomial

    REVERSED_CRC_Polynomial =0X0000;
	for (bit_index=0;bit_index<Number_of_bits_in_CRC;bit_index++)
     {
		Bit_Mask = 1<<bit_index;
				 
		if (0!=(Bit_Mask&Polynomial_CONFIG_WORD))
		{
          REVERSED_CRC_Polynomial=  REVERSED_CRC_Polynomial|(1<<(Number_of_bits_in_CRC-1-bit_index));
		}

	 } 


	   


  calculated_CRC_16bit = Register_Initilisations;// Defined as so at the start

  for ( byte_index = 0; byte_index < Input_number_of_bytes; byte_index++)
  {
           calculated_CRC_16bit ^= (unsigned short)Input_CRC_data_array[byte_index];    // XOR byte into least sig. byte of calculated_CRC_16bit

      for (int Bit_index = 8; Bit_index != 0; Bit_index--) 
      {   
             if (0X0000!=(calculated_CRC_16bit & 0x0001)) 
	         {      // If the LSB is set
             
                calculated_CRC_16bit = (calculated_CRC_16bit>>1)^(REVERSED_CRC_Polynomial);       // Shift right and XOR by REVERSED_CRC_Polynomial

              } else  
		      {// Else LSB is not set
              
				calculated_CRC_16bit=  (calculated_CRC_16bit>>1);      // Just shift right

	           }
      }


  }





  return calculated_CRC_16bit;
}


#endif

/*

Reference material:


Reference 1:

APPLICATION NOTE 27
Understanding and Using Cyclic Redundancy
Checks with Maxim 1-Wire and iButton Products
Mar 29, 2001

Application Note 27: http://www.maximintegrated.com/an27
APPLICATION NOTE 27, AN27, AN 27, APP27, Appnote27, Appnote 27
 2013 Maxim Integrated Products, Inc.


Reference 2:

"Sample 16-bit Modbus Packet" 


Watlow Winona 2 RGH 02/23/05
1241 Bundy Blvd
Winona, MN 55987
Telephone (507) 494-5656
 2004 Watlow Electric Manufacturing Company



Reference 3:

MODBUS over serial line specification and implementation guide V1.0
Modbus.org http://www.modbus.org/ 1/44
12/02/02




*/