
#ifndef Engineering_File_Reader_IO_class_dot_h_
#define Engineering_File_Reader_IO_class_dot_h_



#pragma message("\n *********** ------------------------- ***********************\n")
#pragma message("\n **     _Engineering_File_Reader_IO_class_dot_h_             *\n")
#pragma message("\n **              OCTOBER, 12, 2014                           *\n")
#pragma message("\n *********** _________________________ ***********************\n")
#pragma message("\n \n \n")


/******************* Engineering_File_Reader_IO_class *******************

   Need a class that conviently opens a text file and then reads one 
line of data at a time. Can not use the STDIO calls because I do not 
know if the line is terminated with a '\n' or '\r' or '\0'. This class
searchs for any of these line termination options.

	Also, you do not need to explictly close the file pointer. The
class destructor does this for you. 

******************* Engineering_File_Reader_IO_class *******************/

#include <cstdio>
#include <stdlib.h>
#include <iostream>
#include <cstdio>
#include <cstring>

class Engineering_File_Reader_IO_class
{  

public:


      Engineering_File_Reader_IO_class();
	  ~Engineering_File_Reader_IO_class();

	  unsigned char File_Open( char FILE_name_array[]);
	  unsigned char Fetch_line_from_file( char Single_Line_of_Data[], int &MAX_expected_chars );
	  void          Close_File_Pointer(  );
	

private:

    FILE          *_pvt_Valid_File_Pointer;

	unsigned char _pvt_File_open_status;         
	              // Reports the sucess of the 
	              // opened file.  
                  // File_open_status=0X01 
	              // File opened OK.

	char          _pvt_Reserved_File_Name_Array[1000];
	               // local preserved name of 
	               // Desired file name
	errno_t       _pvt_File_Open_Error;          // Magical file entity.
	unsigned char _pvt_File_Opened_Sucessfully;  // 0X00 if false 
	                                             // !=0X00 if true

	 void          _pvt_ERROR_Alert_message();
     unsigned char _pvt_End_of_line_Detected(int int_form_of_char);
	 unsigned char _pvt_Fetch_line_from_file( char Single_Line_of_Data[], int &MAX_expected_chars);

	 

  };//END class Engineering_File_Reader_IO_class


























  	 void  Engineering_File_Reader_IO_class::_pvt_ERROR_Alert_message()
	{
          
     printf("*************__ERROR_ALERT__**********************\n");
     printf("*                                                *\n");
	 printf("*     The file entity has not been created!!!    *\n");
	 printf("*                                                *\n");
	 printf("*       NO file reads are possible.              *\n");
	 printf("*                                                *\n");
	 printf("*                                                *\n");
	 printf("*    ''Engineering_File_Reader_IO_class''        *\n");
	 printf("*            REPORTED THIS ERROR                 *\n");
	 printf("*                                                *\n");
	 printf("*************_______________**********************\n");
		 	
		getchar();
	};//END  ERROR_Alert_message()


	 

     /* **********************  End_of_line_Detected  *********************

     Detects the following symbols:

     Symbol    Explanation             (decimal vlaue)

     '\r'      Carriage return (CR)    10
     '\n'      Line Feed (LF)          13 
     '\0'      NULL                     0


     If any of these symbols are detected then "End_of_line_Detected" reports
    a "0XFF" otherwise a 0X00 is reported.

   *********************  End_of_line_Detected  **************************/

  unsigned char Engineering_File_Reader_IO_class::_pvt_End_of_line_Detected(int int_form_of_char)
  {
	  char Single_Char;

	  Single_Char =  (char) int_form_of_char;

     if ('\r'==Single_Char)
	 {
		 return 0XFF;
	 }

	  if ('\n'==Single_Char)
	 {
		 return 0XFF;
	 }

	  if ('\0'==Single_Char)
	 {
		 return 0XFF;
	 }
     
	  return 0X00;
 };//END unsigned char End_of_line_Detected(int int_form_of_char) 

  

     /************ Fetch_line_from_file *************************************

     I want a generic function that reads a single line from correctly 
   formed file pointer.  
    
    The single line of data in the raw file could be terminated with any 
  combination of  the following symbols:

   Symbol    Explanation             (decimal value)

   '\r'      Carriage return (CR)    10
   '\n'      Line Feed (LF)          13 
   '\0'      NULL                     0


   Entity Identifier:      Explanation:

   "Single_Line_of_Data"  Product char array. Always NULL terminated

   "MAX_expected_chars"   The maximum number of chars that you want to
                          be placed in "Single_Line_of_Data".  When 
					      the function exits, the value of 
					      "MAX_expected_chars" is the number of chars 
					      in the product array. Original value MUST be less than 
					      256!! 

   "Valid_File_Pointer"   This is the file pointer to the file that you
                          want to extract a single line of data. This 
					      file pointer must be a valid file pointer to an
					      opened file, "r" mode.


   "Reply_Value"         Function feed back.


   Translation of  "Reply_Value"

   Value:        Interpretation:
  
   0X00          All worked OK

   0X01          FILE *Valid_File_Pointer defective

   0X02          Length of line > MAX_expected_chars;

   0X04          No data returned to the "Single_Line_of_Data"

   0X08          More than 2048 bytes were requested

   0X10          END of file detected


   ************ _________________ **************************************/



	unsigned char Engineering_File_Reader_IO_class::_pvt_Fetch_line_from_file( char Single_Line_of_Data[], int &MAX_expected_chars)
	{
      unsigned char Reply_Value;      // Feed back

	  int Extracted_number_of_chars=0;// Actual number of chars that are
	                                  // placed in the "Single_Line_of_Data"

	//  char Single_char;             // Single char aquitred from file

	  int int_file_char;              // Raw int from file. Might include NULL              


	  
    
	  Reply_Value =0X00;   //All good so far...


	   if (0XFF!=_pvt_File_Opened_Sucessfully)
	  {

         printf("ERROR! FILE *Valid_File_Pointer defective\n ''Engineering_File_Reader_IO_class//_pvt_Fetch_line_from_file'' reports this. \n");
		  getchar();
		 Reply_Value = 0X01;
		 return Reply_Value;

	  }

	  if (2048<MAX_expected_chars)
	  {

         printf("ERROR! MAX_expected_chars exceeds 2048!\n ''Engineering_File_Reader_IO_class//_pvt_Fetch_line_from_file'' reports this. \n");
		 Reply_Value = 0X08;
		 getchar();
		 return Reply_Value;
	  }

	  	

	  int_file_char =  fgetc(_pvt_Valid_File_Pointer);

	
 
     if (NULL==int_file_char)
	  {

         printf("ERROR! FILE *Valid_File_Pointer defective\n ''Engineering_File_Reader_IO_class'' reports this. \n");
		  getchar();
		 Reply_Value = 0X01;
		 return Reply_Value;

	  }


	  // File pointer OK. Proceed to next step.

	  while( (0X00==_pvt_End_of_line_Detected(int_file_char)) &&(EOF!=int_file_char))
	  {

		  Single_Line_of_Data[Extracted_number_of_chars]=(char)int_file_char;
		  Single_Line_of_Data[Extracted_number_of_chars+1]='\0';
		
		
	     //_________ TEST for exceeding MAX chars _________
		 if (MAX_expected_chars<Extracted_number_of_chars)
		 {
             printf("ERROR!  Length of line > MAX_expected_chars  ''Engineering_File_Reader_IO_class'' reports this. \n");
			  getchar();
			 Reply_Value = 0X02;
		     return Reply_Value;
		 }
          //_________ **************************** _________

            int_file_char =  fgetc(_pvt_Valid_File_Pointer);
			Extracted_number_of_chars++;

	  };//END  while (0X00==End_of_line_Detected(int_file_char))


	   if (EOF==int_file_char)
	  {

       // printf("ERROR! END of file detected \n ''Fetch_line_from_file'' reports this. \n");
		

		 printf("END OF FILE ''%s'' \n",_pvt_Reserved_File_Name_Array);

		   //getchar();
		 Reply_Value = 0X10;
		 fclose(_pvt_Valid_File_Pointer);// END OF file?  Close pointer
		 return Reply_Value;
	  }
     
       MAX_expected_chars = Extracted_number_of_chars;


       if (0==Extracted_number_of_chars)
	    {
        Reply_Value = 0X04;
		return Reply_Value;
	    }


	  return Reply_Value;
	};//unsigned char _pvt_Fetch_line_from_file



			  
       Engineering_File_Reader_IO_class::Engineering_File_Reader_IO_class()
	 {
       _pvt_File_Opened_Sucessfully =0X00;// File has not be opend sucessfully.   

	 };//END  Engineering_File_Reader_IO_class::Engineering_File_Reader_IO_class()



      Engineering_File_Reader_IO_class:: ~Engineering_File_Reader_IO_class()
	 {

	   if ((NULL!=_pvt_Valid_File_Pointer)&&(0XFF==_pvt_File_open_status))
	   {
          fclose(_pvt_Valid_File_Pointer);//Redundant 
	   }

	 };//END  Engineering_File_Reader_IO_class:: ~Engineering_File_Reader_IO_class()


	  	  unsigned char Engineering_File_Reader_IO_class::File_Open( char FILE_name_array[])
        {
            unsigned char Return_Message=0X00;// 

		

            strncpy_s(_pvt_Reserved_File_Name_Array,FILE_name_array,(sizeof(_pvt_Reserved_File_Name_Array)-1));
      
            _pvt_File_Open_Error = fopen_s(&_pvt_Valid_File_Pointer,_pvt_Reserved_File_Name_Array, "r"); 


		  if ((NULL==_pvt_Valid_File_Pointer)||(0!=_pvt_File_Open_Error))
		  {
			_pvt_ERROR_Alert_message();
			fclose(_pvt_Valid_File_Pointer);
			
			return 0X01;
		  }
          
		 
         
		  _pvt_File_Opened_Sucessfully =0XFF;
          
          return Return_Message;

	   };// END   Engineering_File_Reader_IO_class::File_Open




		  
	


	/************ Fetch_line_from_file *************************************

     I want a generic function that reads a single line from correctly 
   formed file pointer.  
    
    The single line of data in the raw file could be terminated with any 
  combination of  the following symbols:

   Symbol    Explanation             (decimal vlaue)

   '\r'      Carriage return (CR)    10
   '\n'      Line Feed (LF)          13 
   '\0'      NULL                     0


   Entity Identifier:      Explanation:

   "Single_Line_of_Data"  Product char array. Always NULL terminated

   "MAX_expected_chars"   The maximum number of chars that you want to
                         be placed in "Single_Line_of_Data".  When 
					     the function exits, the value of 
					     "MAX_expected_chars" is the number of chars 
					     in the product array. Original value MUST be less than 
					     256!! 

   "Valid_File_Pointer"   This is the file pointer to the file that you
                        want to extract a single line of data. This 
					    file pointer must be a valid file pointer to an
					    opened file, "r" mode.


   "Reply_Value"         Function feed back.


   Translation of        "Reply_Value"

   Value:        Interpretation:
  
   0X00          All worked OK
   
   0X01          FILE *Valid_File_Pointer defective
   
   0X02          Length of line > MAX_expected_chars;
   
   0X04          No data returned to the "Single_Line_of_Data"
   
   0X08          More than 2048 bytes were requested
   
   0X10          END of file detected
   
   0X20          "File_Open( char FILE_name_array[])" not invoked

   ************ _________________ **************************************/




    unsigned char Engineering_File_Reader_IO_class::Fetch_line_from_file( char Single_Line_of_Data[], int &MAX_expected_chars )
	{

		unsigned char Reply_Message=0X00;

 
       if (0XFF!=_pvt_File_Opened_Sucessfully)
	   {
          _pvt_ERROR_Alert_message();

		  return 0X20;

	   }


	   Reply_Message = _pvt_Fetch_line_from_file(  Single_Line_of_Data, MAX_expected_chars);

	   Single_Line_of_Data[MAX_expected_chars]='\0';

	   return Reply_Message;

	};//END  unsigned char Fetch_line_from_file

	
	 void Engineering_File_Reader_IO_class::Close_File_Pointer(  )
	{

		if ((NULL!=_pvt_Valid_File_Pointer)&&(0XFF==_pvt_File_open_status))
		{
		 fclose(_pvt_Valid_File_Pointer);//Redundant 
		}

		return ;

	 };//END Engineering_File_Reader_IO_class::Close_File_Pointer


#endif 