/*****************  Engineering_File_Writer_IO_class ********************

	This class is intended for data aqusition. Specifically, there are 
plenty of cases where I want to interrupt an experiment at an arbitrary
point in time.

     If you do do not explicitly close the file pointer (ofstream,STDIO)
you are at the mercy of the operating system.  Sometimes your data is 
written, sometimes not.  

 This class reduces the probability that you data will be lost when you
exit at an arbitrary time in execution.  Typically only a line or two of
data are lost.

 Also, you are not obligated to explicitly "close" the file pointer. 
This task is performed after each and every "write".

********************  ________________________ *************************/
#ifndef _CRT_SECURE_NO_WARNINGS 
#define _CRT_SECURE_NO_WARNINGS
#pragma message("\n ************* ------------------------- ***********************  \n")
#pragma message("\n **    COMPILER WARNING FUNCTION DEACTIVATED                   *  \n")
#pragma message("\n **              January, 2, 2014                              *  \n")
#pragma message("\n ************* _________________________ ***********************  \n \n \n")
#endif





#include <iostream>
#include <cstdio>
#include <cstring>



#ifndef  define_256_chars
#define  define_256_chars (256)
#endif 


#ifndef _Engineering_File_Writer_IO_class_dot_h_
#define _Engineering_File_Writer_IO_class_dot_h_


#pragma message("\n *********** ------------------------- ***********************\n")
#pragma message("\n **     _Engineering_File_Writer_IO_class_dot_h_             *\n")
#pragma message("\n **             January, 10, 2018                            *\n")
#pragma message("\n *********** _________________________ ***********************\n")
#pragma message("\n \n \n")



class Engineering_File_Writer_IO_class
{  



public:

   Engineering_File_Writer_IO_class();
   ~Engineering_File_Writer_IO_class();

   unsigned char   File_open               (char   FILE_name_array_MAX_256_chars[]);
   unsigned char   Write_float_to_file     (float  float_varible);
   unsigned char   Write_double_to_file    (double double_varible);
   unsigned char   Write_int_to_file       (int    integer_variable);
   unsigned char   Write_char_array_to_file(char   char_array_MAX_256_chars[]);
   unsigned char   Write_newline_to_file   ();
   unsigned char   Write_comma_to_file     ();


 private:

	FILE          *_pvt_Engineering_file_writer;   // Writes the engineering
	                                               // file.

	unsigned char _pvt_File_open_status;           // Reports the sucess
	                                               //  of the  opened file.  
	                                               // File opened OK.

	char          _pvt_Reserved_File_Name_Array[1000];
	// local preserved name
	// of Desired file name
	errno_t       _pvt_File_Open_Error;            // Magical file entity.

	unsigned char _pvt_File_Opened_Sucessfully;    // 0X00 if false 
	                                                // !=0X00 if true    
    void          ERROR_Alert_message();


/********************  ____  74 chars ________ *************************/




};//END class Engineering_File_Writer_IO_class










 void Engineering_File_Writer_IO_class::ERROR_Alert_message()
	{
          
     printf("*************__ERROR_ALERT__**********************\n");
     printf("*                                                *\n");
	 printf("*     The file entity has not been created!!!    *\n");
	 printf("*                                                *\n");
	 printf("*       NO file writes are possible.             *\n");
	 printf("*                                                *\n");
	 printf("*                                                *\n");
	 printf("*''__pvt_Engineering_File_Writer_IO_class_dot_h_''*\n");
	 printf("*            REPORTED THIS ERROR                 *\n");
	 printf("*                                                *\n");
	 printf("*************_______________**********************\n");
		 	
	 getchar();
		
	};//END  ERROR_Alert_message()



 	   /************** File_open( char FILE_name_array_MAX_256_chars[]) *****************
       Opens a file named "FILE_name_array_MAX_256_chars[]" 

	   Varibble Name:         Translation:
	   "FILE_name_array_MAX_256_chars[]"    Name of file that you want to open.
	                          The file name must be NULL terminated.


		"Return_Message"      Returns 0X00 when the desired file opened. 
		                      without problems, otherwise, ERROR.

	   **************** __________________________________ ***************/


unsigned char Engineering_File_Writer_IO_class::File_open( char FILE_name_array_MAX_256_chars[])
{
  unsigned char Return_Message;// 

  unsigned int length_of_file_name_array;





   Return_Message =0X00;// So far so good.



   length_of_file_name_array =strlen(FILE_name_array_MAX_256_chars);


   if (define_256_chars<length_of_file_name_array)
   {
	   
	 printf("*************__ERROR_ALERT__**********************\n");
     printf("*                                                *\n");
	 printf("* Length of ''FILE_name_array_MAX_256_chars''    *\n");
	 printf("*                                                *\n");
	 printf("*     EXCEEDS the maximum of 250 characters.     *\n");
	 printf("*                                                *\n");
	 printf("*''__pvt_Engineering_File_Writer_IO_class_dot_h_''*\n");
	 printf("*            REPORTED THIS ERROR                 *\n");
	 printf("*                                                *\n");
	 printf("*************_______________**********************\n");
	 
	 ERROR_Alert_message();

	 return 0X01;
   }
  

   strncpy_s(_pvt_Reserved_File_Name_Array,FILE_name_array_MAX_256_chars,(sizeof(_pvt_Reserved_File_Name_Array)-1));
      
   _pvt_File_Open_Error = fopen_s(&_pvt_Engineering_file_writer,_pvt_Reserved_File_Name_Array, "w"); 


		  if ((NULL==_pvt_Engineering_file_writer)||(0!=_pvt_File_Open_Error))
		  {
			ERROR_Alert_message();
			Return_Message =0X01;//Error Message
			_pvt_File_open_status = 0X01;
			return Return_Message;
		  }
		  //fflush(_pvt_Engineering_file_writer);
          fclose(_pvt_Engineering_file_writer);
		 
          _pvt_File_open_status = 0X00;//  
		  _pvt_File_Opened_Sucessfully =0XFF;
          
          return Return_Message;

 };// END Engineering_File_Writer_IO_class::File_open( char FILE_.......


 /********************  Write_float_to_file *************************

 Writes a float to the engineering file.  The format of the float is

 "%E" The mantissia and the ordinate are ALWAYS reported.

 Entity:               Translation:
 
 float_varible          The varible that you want reported.
	   
 Return_Message        Returns 0X00 if the file write worked.

********************  __________________ ***************************/




unsigned char Engineering_File_Writer_IO_class::Write_float_to_file(float float_varible)
{
  
  unsigned char Return_Message =0X00;

		  		
  if (0X00!=_pvt_File_open_status)
  {
   ERROR_Alert_message();
   Return_Message =0X01;//Error Message
   return Return_Message;
   }

   _pvt_File_Open_Error = fopen_s(&_pvt_Engineering_file_writer,_pvt_Reserved_File_Name_Array,"a");

	while (13==_pvt_File_Open_Error)
	{

       _pvt_File_Open_Error = fopen_s(&_pvt_Engineering_file_writer,_pvt_Reserved_File_Name_Array,"a");
	   fprintf(stderr,"''Engineering_File_Writer_IO_class'' waits for operating system priveleges \n");
	   

	 
	}

   if ((NULL==_pvt_Engineering_file_writer)||(0!=_pvt_File_Open_Error))
   {
    ERROR_Alert_message();
	Return_Message =0X01;//Error Message
    _pvt_File_open_status = 0X01;
	return Return_Message;
	}



    fprintf(_pvt_Engineering_file_writer,"%E",float_varible);
	fflush(_pvt_Engineering_file_writer);
	fclose(_pvt_Engineering_file_writer);

	return Return_Message;

};//END  Engineering_File_Writer_IO_class::Write_float_to_file(float..



/*******************  Write_double_to_file **************************

Writes a float to the engineering file.  The format of the float is

 "%E" The mantissia and the ordinate are ALWAYS reported.

 Varible:               Translation:
 double_varible         The varible that you want reported.
	   
 Return_Message        Returns 0X00 if the file write worked.

******************  __________________ ******************************/



unsigned char Engineering_File_Writer_IO_class::Write_double_to_file(double double_varible)
{
  unsigned char Return_Message=0X00;
     
   if (0X00!=_pvt_File_open_status)
   {
    ERROR_Alert_message();
	Return_Message =0X01;//Error Message
	return Return_Message;
   }
		 
    _pvt_File_Open_Error= fopen_s(&_pvt_Engineering_file_writer, _pvt_Reserved_File_Name_Array, "a");

		while (13==_pvt_File_Open_Error)
	{

       _pvt_File_Open_Error = fopen_s(&_pvt_Engineering_file_writer,_pvt_Reserved_File_Name_Array,"a");
	  fprintf(stderr,"''Engineering_File_Writer_IO_class'' waits for operating system priveleges \n");
	   

	   
	}


    if ((NULL==_pvt_Engineering_file_writer)||(0!=_pvt_File_Open_Error))
    {
	 ERROR_Alert_message();
	 Return_Message =0X01;//Error Message
	 _pvt_File_open_status = 0X01;
	 return Return_Message;
	}

    fprintf(_pvt_Engineering_file_writer,"%E",double_varible);
	fflush(_pvt_Engineering_file_writer);
	fclose(_pvt_Engineering_file_writer);

	return Return_Message;
	
 };//END  Engineering_File_Writer_IO_class::Write_double_to_file(..




/*********************  Write_int_to_file ******************************

 Writes a float to the engineering file.  The format of the float is

 "%E" The mantissia and the ordinate are ALWAYS reported.

  Varible:          Translation:
	   
  integer_variable        The varible that you want reported.	   
  Return_Message     Returns 0X00 if the file write worked.

********************  __________________ *******************************/

unsigned char Engineering_File_Writer_IO_class::Write_int_to_file(int integer_variable)
{
 
   unsigned char Return_Message;
     
   if (0X00!=_pvt_File_open_status)
   {
     ERROR_Alert_message();
	 Return_Message =0X01;//Error Message
	 return Return_Message;
	}
		 
   Return_Message = 0X00;

   _pvt_File_Open_Error = fopen_s(&_pvt_Engineering_file_writer, _pvt_Reserved_File_Name_Array, "a");

   	while (13==_pvt_File_Open_Error)
	{

       _pvt_File_Open_Error = fopen_s(&_pvt_Engineering_file_writer,_pvt_Reserved_File_Name_Array,"a");
	  fprintf(stderr,"''Engineering_File_Writer_IO_class'' waits for operating system priveleges \n");
	   
	 
	}



  

   if ((NULL==_pvt_Engineering_file_writer)||(0!=_pvt_File_Open_Error))
   {
	 ERROR_Alert_message();
	 Return_Message =0X01;//Error Message
	 _pvt_File_open_status = 0X01;
	
	 return Return_Message;
	}


    fprintf(_pvt_Engineering_file_writer,"%i",integer_variable);
	fflush(_pvt_Engineering_file_writer);
    fclose(_pvt_Engineering_file_writer);


	return Return_Message;

};//END  unsigned char Engineering_File_Writer_IO_class::Write_int_to_file(int..



unsigned char Engineering_File_Writer_IO_class::Write_char_array_to_file(char char_array_MAX_256_chars[])
{
  unsigned char Return_Message;

  unsigned int length_of_char_array;
     
  if (0X00!=_pvt_File_open_status)
  {
    ERROR_Alert_message();
	Return_Message =0X01;//Error Message
	return Return_Message;
  }

  Return_Message =0X00;

  _pvt_File_Open_Error= fopen_s(&_pvt_Engineering_file_writer, _pvt_Reserved_File_Name_Array, "a");

  	while (13==_pvt_File_Open_Error)
	{

       _pvt_File_Open_Error = fopen_s(&_pvt_Engineering_file_writer,_pvt_Reserved_File_Name_Array,"a");
	   fprintf(stderr,"''Engineering_File_Writer_IO_class'' waits for operating system priveleges \n");
	   

	
	}


  if ((NULL==_pvt_Engineering_file_writer)||(0!=_pvt_File_Open_Error))
  {
	ERROR_Alert_message();
	Return_Message =0X01;//Error Message
	_pvt_File_open_status = 0X01;
	return Return_Message;
  }



  
   length_of_char_array =strlen(char_array_MAX_256_chars);


   if (define_256_chars<length_of_char_array)//0X01
   {
	   
	 printf("*************__ERROR_ALERT__**********************\n");
     printf("*                                                *\n");
	 printf("* Length of ''FILE_name_array_MAX_256_chars''    *\n");
	 printf("*                                                *\n");
	 printf("*     EXCEEDS the maximum of 250 characters.     *\n");
	 printf("*                                                *\n");
	 printf("*''__pvt_Engineering_File_Writer_IO_class_dot_h_''*\n");
	 printf("*            REPORTED THIS ERROR                 *\n");
	 printf("*                                                *\n");
	 printf("*************_______________**********************\n");
	 
	 ERROR_Alert_message();

	 return 0X01;
   }
  


  fprintf(_pvt_Engineering_file_writer,"%s",char_array_MAX_256_chars);
  fflush(_pvt_Engineering_file_writer);
  fclose(_pvt_Engineering_file_writer);

   return Return_Message;

  };//END Engineering_File_Writer_IO_class::Write_char_array_to_file(char...




/**********************  Write_newline_to_file **************************

Writes a "new_line"(char(10))to the engineering file.  
	
Return_Message        Returns 0X00 if the file write worked.


***********************  __________________ *****************************/

unsigned char Engineering_File_Writer_IO_class::Write_newline_to_file()
{
   unsigned char Return_Message =0X00;
		  		
   if (0X00!=_pvt_File_open_status)
   {
     ERROR_Alert_message();
	 Return_Message =0X01;//Error Message
	 return Return_Message;
	}


   _pvt_File_Open_Error= fopen_s(&_pvt_Engineering_file_writer, _pvt_Reserved_File_Name_Array, "a");


   	while (13==_pvt_File_Open_Error)
	{

       _pvt_File_Open_Error = fopen_s(&_pvt_Engineering_file_writer,_pvt_Reserved_File_Name_Array,"a");
	   fprintf(stderr,"''Engineering_File_Writer_IO_class'' waits for operating system priveleges \n");
	   
	}


   if ((NULL==_pvt_Engineering_file_writer)||(0!=_pvt_File_Open_Error))
   {
	ERROR_Alert_message();
	Return_Message =0X01;//Error Message
	_pvt_File_open_status = 0X01;
	return Return_Message;
   }
		 


    fprintf(_pvt_Engineering_file_writer,"\n");
	fflush(_pvt_Engineering_file_writer);
    fclose(_pvt_Engineering_file_writer);

    return Return_Message;

 };//END  unsigned char Engineering_File_Writer_IO_class::Write_newline_to_file()



 /**********************  Write_comma_to_file **************************

 Writes a comma(',')to the engineering file.  The format of the float is
	
 Return_Message        Returns 0X00 if the file write worked.


 ********************  __________________ ******************************/

unsigned char Engineering_File_Writer_IO_class::Write_comma_to_file()
{
   unsigned char Return_Message =0X00;
  		
   if (0X00!=_pvt_File_open_status)
	{
      ERROR_Alert_message();
	  Return_Message =0X01;//Error Message
	   return Return_Message;
     }


	_pvt_File_Open_Error= fopen_s(&_pvt_Engineering_file_writer, _pvt_Reserved_File_Name_Array, "a");

		while (13==_pvt_File_Open_Error)
	{

       _pvt_File_Open_Error = fopen_s(&_pvt_Engineering_file_writer,_pvt_Reserved_File_Name_Array,"a");
	   fprintf(stderr,"''Engineering_File_Writer_IO_class'' waits for operating system priveleges \n");
	   
	  
	}


	if ((NULL==_pvt_Engineering_file_writer)||(0!=_pvt_File_Open_Error))
	{
	  ERROR_Alert_message();
	  Return_Message =0X01;//Error Message
	  _pvt_File_open_status = 0X01;
	  return Return_Message;
	 }

     fprintf(_pvt_Engineering_file_writer,",");
	 fflush(_pvt_Engineering_file_writer);
	 fclose(_pvt_Engineering_file_writer);

	 return Return_Message;

 };//END Engineering_File_Writer_IO_class::Write_comma_to_file()



Engineering_File_Writer_IO_class::Engineering_File_Writer_IO_class()
{
  _pvt_File_open_status = 0X01;// Used in testing the file I/O entity
  strcpy_s(_pvt_Reserved_File_Name_Array,define_256_chars,"  ");
  _pvt_File_Opened_Sucessfully = 0X00;// detects the first time that 
		                         // a file is opened sucessfully 
};//END Engineering_File_Writer_IO_class() 
	

     
 Engineering_File_Writer_IO_class::~Engineering_File_Writer_IO_class()
 {
  if ((NULL!=_pvt_Engineering_file_writer)&&(0X00!=_pvt_File_Opened_Sucessfully))
  {//Means file pointer is open
   fflush(_pvt_Engineering_file_writer);
   fclose(_pvt_Engineering_file_writer);// Garbage collection
   }
 }


#endif