/************************* _NI488_GPIB_Manager_dot_h_********************


  NOTE: Typically, the "GPIB_Secondary_Address" is set to zero.  
        Unless you have excellent evedence, always adjust 
        this value to '0'!

		REMEMBER THIS!!!!

********************************************************************************/


/******** _NI488_GPIB_Manager_dot_h_ READ ME *********************************

  The compiler must be able to include "IEEE_488_GPIB_object_code_32bit.obj" 
in to the project.

   If you are using Windows Visual Studio, then you must do the following:

   1) Place a copy of these files in the same directorty as this file. 
   2) "Drag and drop" a copy of this file in your "Solution Explorer".
      The "Solution Explorer" is  window pane where you observe your
	  "Header Files", "Source Files", and (maybe) "External Dependancies"
   3) You must drag and drop the object where you observe "Source Files"
   4) Alternatively you can
        A) Place mouse cursor on the "Source Files" icon
		B) Right mouse click
		C) move yoe mouse to "ADD/Existing Item...." (Cntrl Shift A)
		D) Find "IEEE_488_GPIB_object_code_32bit.obj"





If you do not do associate the *.obj file with the project, then you will
observe compiler errors such as:



1>Gerric_GPIB_project.obj : error LNK2001: unresolved external symbol _iberr
1>Gerric_GPIB_project.obj : error LNK2001: unresolved external symbol _ibsta
1>Gerric_GPIB_project.obj : error LNK2001: unresolved external symbol _ibcnt




THe original form of "IEEE_488_GPIB_object_code_32bit.obj"  was derived from
Measurement Computing Company http://www.mccdaq.com/ 


This is a problem.


The there are two forms of this original file("gpib-32.obj")


The differences are:

Vendor:                             File size:
National Instruments                52K byte
Measurement Computing Company       31K byte
  
THere is no obvious difference between these two files other than size.

  I have used the 31K byte version sisnce there are no copyright marks
in the 31 kilobyte file.

******** _________ *****************************************************/






/******************* EXAMPLE_USAGE *********************************
	  

    IEEE_488_GPIB_manager Agilent_34401A_GPIB_Addr_22;

	//Agilent_34401A_GPIB_Addr_22.Report_avalible_GPIB_interfaces();// FIND GPIB interfaces


	Agilent_34401A_GPIB_Addr_22.GPIB_Primary_Address =22;
	Agilent_34401A_GPIB_Addr_22.GPIB_Secondary_Address =0;
	Agilent_34401A_GPIB_Addr_22.GPIB_Board_Index =2;


	Agilent_34401A_GPIB_Addr_22.Transmitt_a_char_array_to_GPIB("*IDN?",strlen("*IDN?"));
	Agilent_34401A_GPIB_Addr_22.Receive_a_char_array_from_GPIB(Product_Array,Message_Length);

	Product_Array[Message_Length]='\0';//

	printf("Agilent_34401A_GPIB_Addr_22 ID=%s \n",gilent_34401A_GPIB_Addr_22);

******************* EXAMPLE_USAGE **********************************/








#include <windows.h>
#include <stdio.h>




/***************  COMPILER strcpy_s appeasement ********
  Need to use a # define to appease  strcpy_s
******************  ___________________ ***************/
#ifndef   define_256_chars  
#define   define_256_chars  256
#endif 



#ifndef  _IEEE_488_GPIB_Manager_dot_h_
#define  _IEEE_488_GPIB_Manager_dot_h_


#pragma message("\n ************* ------------------------- ***********************  \n")
#pragma message("\n **          _IEEE_488_GPIB_Manager_dot_h_                     *  \n")
#pragma message("\n **             October 29, 2014                               *  \n")
#pragma message("\n ************* _________________________ ***********************  \n \n \n")

//#include "ni4882.h"// National Instruments only!!  Also need a 51k byte gpib-32.obj file
                     // These files are avalible from National Instruments.


#include "IEEE_488_GPIB_definitions.h"

class IEEE_488_GPIB_manager 
{

 public:


    IEEE_488_GPIB_manager();
	 ~IEEE_488_GPIB_manager();//Destructor
          	  
	int            GPIB_Board_Index;             /* Interface Index (GPIB0=0,GPIB1=1,etc.)  */
    int            GPIB_Primary_Address;         /* Device primary address                  */
    int            GPIB_Secondary_Address;       /* Device secondary address(typically ZERO)*/


   
	unsigned long  Transmitt_a_char_array_to_GPIB(char GPIB_message_char_array[], unsigned int &Number_of_chars_in_message);
    unsigned long  Receive_a_char_array_from_GPIB(char GPIB_message_char_array[], unsigned int &Number_of_chars_in_message);
	unsigned char  Report_avalible_GPIB_interfaces();

	int            Generate_Device_Control_pntr(void);
	




private:

    int           _pvt_NI_GPIB_device_ID_pntr;     /* Magical GPIB memory address  */
	char          _pvt_char_YN;                    /* used in yes/no questions     */ 
	unsigned char _pvt_GPIB_INIT_flag;             /* =0XFF when GPIB BUS is OK    */
    FILE          *_pvt_Interface_Report_FILE_pntr;// This reports any valid equipment information  
	void          _pvt_Display_NI488_Error_Codes(int Device_Identifier );	
    void          _pvt_Test_GPIB_INIT_flag( );
	void          _pvt_Report_GPIB_interface_parameters();



};// END class IEEE_488_GPIB_manager





/************************ _pvt_Display_NI488_Error_Codes *******************

Displays status error codes. 

************************ _pvt_Display_NI488_Error_Codes *******************/



  void  IEEE_488_GPIB_manager::_pvt_Display_NI488_Error_Codes(int Device_Identifier )
	{

  

	  if (ibsta & ERR )  printf("ERROR CODE: ERR  \n");
      if (ibsta & TIMO)  printf("ERROR CODE: TIMO \n"); 
      if (ibsta & END )  printf("ERROR CODE: END  \n");
      if (ibsta & SRQI)  printf("ERROR CODE: SRQI \n");
      if (ibsta & RQS )  printf("ERROR CODE: RQS  \n");
      if (ibsta & CMPL)  printf("ERROR CODE: CMPL \n");
      if (ibsta & LOK )  printf("ERROR CODE: LOK  \n");
      if (ibsta & REM )  printf("ERROR CODE: REM  \n");
      if (ibsta & CIC )  printf("ERROR CODE: CIC  \n");
      if (ibsta & ATN )  printf("ERROR CODE: ATN  \n");
      if (ibsta & TACS)  printf("ERROR CODE: TACS \n");
      if (ibsta & LACS)  printf("ERROR CODE: LACS \n");
      if (ibsta & DTAS)  printf("ERROR CODE: DTAS \n");
      if (ibsta & DCAS)  printf("ERROR CODE: DCAS \n");

	  /*
	  //
      // GPIB status bit vector: global variable ibsta and wait mask
      //
      #define ERR   (1<<15)  // Error detected
      #define TIMO  (1<<14)  // Timeout
      #define END   (1<<13)  // EOI or EOS detected
      #define SRQI  (1<<12)  // SRQ detected by CIC
      #define RQS   (1<<11)  // Device needs service
      #define CMPL  (1<<8)   // I/O completed
      #define LOK   (1<<7)   // Local lockout state
      #define REM   (1<<6)   // Remote state
      #define CIC   (1<<5)   // Controller-in-Charge
      #define ATN   (1<<4)   // Attention asserted
      #define TACS  (1<<3)   // Talker active
      #define LACS  (1<<2)   // Listener active
      #define DTAS  (1<<1)   // Device trigger state
      #define DCAS  (1<<0)   // Device clear state
	  */
	 


      if (iberr == EDVR)  printf("ERROR CODE: EDVR <DOS Error>                 \n");
      if (iberr == ECIC)  printf("ERROR CODE: ECIC <Not Controller-In-Charge>  \n");
      if (iberr == ENOL)  printf("ERROR CODE: ENOL <No Listener>               \n");
      if (iberr == EADR)  printf("ERROR CODE: EADR <Address error>             \n");
      if (iberr == EARG)  printf("ERROR CODE: EARG <Invalid argument>          \n");
      if (iberr == ESAC)  printf("ERROR CODE: ESAC <Not System Controller>     \n");
      if (iberr == EABO)  printf("ERROR CODE: EABO <Operation aborted>         \n");
      if (iberr == ENEB)  printf("ERROR CODE: ENEB <No GPIB board>             \n");
      if (iberr == EDMA)  printf("ERROR CODE: EDMA <Error performing DMA>      \n");
      // NO (iberr == 9)
      if (iberr == EOIP)  printf("ERROR CODE: EOIP <Async I/O in progress>     \n");
      if (iberr == ECAP)  printf("ERROR CODE: ECAP <No capability>             \n");
      if (iberr == EFSO)  printf("ERROR CODE: EFSO <File system error>         \n");
	  // NO(iberr == 13)
      if (iberr == EBUS)  printf("ERROR CODE: EBUS <Command error>             \n");
      if (iberr == ESTB)  printf("ERROR CODE: ESTB <Status byte lost>          \n");
      if (iberr == ESRQ)  printf("ERROR CODE: ESRQ <SRQ remains asserted>      \n");
	  // NO(iberr == 17)
	  // NO(iberr == 18)
	  // NO(iberr == 19)
      if (iberr == ETAB)  printf("ERROR CODE: ETAB <Table Overflow>            \n");
	  if (iberr == ELCK)  printf("ERROR CODE: ELCK <Address or board is locked>\n");
	  if (iberr == EARM)  printf("ERROR CODE: EARM <The ibnotify Callback failed to rearm>\n");
	  if (iberr == EHDL)  printf("ERROR CODE: EHDL <The input handle is invalid>\n");
	  // NO(iberr == 24)
	  // NO(iberr == 25)
	  if (iberr == EWIP)  printf("ERROR CODE: EWIP <Wait already in progress on input ud>\n");
	  if (iberr == ERST)  printf("ERROR CODE: ERST <The event notification was cancelled due to a reset of the interface>\n");
	  if (iberr == EPWR)  printf("ERROR CODE: EPWR <The system or board has lost power or gone to standby>\n");


	




	  /*
	  //
      // Error messages returned in global variable iberr
      //
      #define EDVR   0  // System error
      #define ECIC   1  // Function requires GPIB board to be CIC
      #define ENOL   2  // Write function detected no Listeners
      #define EADR   3  // Interface board not addressed correctly
      #define EARG   4  // Invalid argument to function call
      #define ESAC   5  // Function requires GPIB board to be SAC
      #define EABO   6  // I/O operation aborted
      #define ENEB   7  // Non-existent interface board
      #define EDMA   8  // Error performing DMA
      #define EOIP  10  // I/O operation started before previous operation completed
      #define ECAP  11  // No capability for intended operation
      #define EFSO  12  // File system operation error
      #define EBUS  14  // Command error during device call
      #define ESTB  15  // Serial poll status byte lost
      #define ESRQ  16  // SRQ remains asserted
      #define ETAB  20  // The return buffer is full
      #define ELCK  21  // Address or board is locked
      #define EARM  22  // The ibnotify Callback failed to rearm
      #define EHDL  23  // The input handle is invalid
      #define EWIP  26  // Wait already in progress on input ud
      #define ERST  27  // The event notification was cancelled due to a reset of the interface
      #define EPWR  28  // The system or board has lost power or gone to standby
	  */




	   if (0X0000!=(ibsta&0XFFFF))
	  {
          ibonl (Device_Identifier,0);//Deactivate bus
	  }





     

	};//END  void  IEEE_488_GPIB_manager::_pvt_Display_NI488_Error_Codes(int Device_Identifier )



  
/************************ _pvt_Test_GPIB_INIT_flag *******************




************************ ________________________ *******************/



     void  IEEE_488_GPIB_manager::_pvt_Test_GPIB_INIT_flag( )
	 {
         if (0XFF!=_pvt_GPIB_INIT_flag)//ERROR ALRT
		 {
                 
			_pvt_char_YN ='n';
			while ('y'!= _pvt_char_YN)
			{
             printf("********* ERROR_ALERT *** ERROR_ALERT *** ERROR_ALERT  ************\n");
		     printf("*                                                                 *\n");
		     printf("*      The GPIB BUS has NOT been initialised correctly!!          *\n");
		     printf("*                                                                 *\n");
		     printf("*                                                                 *\n");
		     printf("*           ''IEEE_488_GPIB_manager'' will now puke on you.          **\n");
		     printf("********* ___________ *** ___________ *** ___________  ************\n\n\n");

			 _pvt_Report_GPIB_interface_parameters();

             printf("Type 'y' to acknowlege this message......"); 
		     _pvt_char_YN = (char)getchar();
			 }


		 }
      

	 };//END  void  IEEE_488_GPIB_manager::_pvt_Test_GPIB_INIT_flag( )




	   IEEE_488_GPIB_manager::IEEE_488_GPIB_manager()//Constructor
	 {

		 
     GPIB_Board_Index=-1;                     /* BOGUS VALUE     */
     GPIB_Primary_Address=-1;                 /* BOGUS VALUE     */
     GPIB_Secondary_Address=-1;               /* TYPICAL VALUE   */
	 _pvt_NI_GPIB_device_ID_pntr=-1;          /* BOGUS VALUE     */
	 _pvt_GPIB_INIT_flag =0X00;               /* NOT initialised */
    
	 };//END IEEE_488_GPIB_manager::IEEE_488_GPIB_manager()//Constructor



	    void IEEE_488_GPIB_manager::_pvt_Report_GPIB_interface_parameters()
	 {
		_pvt_char_YN ='n';
		while ('y'!= _pvt_char_YN)
		{
         printf("\n\n\n\n\n");
		 printf("GPIB_Board_Index      = %i \n",GPIB_Board_Index);
		 printf("GPIB_Primary_Address  = %i \n",GPIB_Primary_Address);
	     printf("GPIB_Secondary_Address= %i \n\n\n",GPIB_Secondary_Address);
		 printf("Type 'y' to acknowlege this message......"); 
         _pvt_char_YN = (char)getchar();
		}

	  };//END  void IEEE_488_GPIB_manager::Report_GPIB_interface_parameters()


      /***************** Transmitt_a_char_array_to_GPIB *****************


	  Entity:                      I/O condition: Explanation:

	  "GPIB_message_char_array"    Input         A message that you want 
	                                             to deliver to the GPIB 
											     device.  

      "Number_of_chars_in_message" INPUT         The number of chars in  
	                                             "GPIB_message_char_array"   
	   
	  "Number_of_chars_in_message" OUTPUT        The number of chars 
	                                            actually delivered to GPIB  
	                                                


	  ****************** _____________________________ *********************/
		  
	   unsigned long  IEEE_488_GPIB_manager::Transmitt_a_char_array_to_GPIB(char GPIB_message_char_array[], unsigned int &Number_of_chars_in_message)
	   {
		  
            int INT_OK;

		   //********** TEST FOR INITILISATION *****************
		   if (0XFF!=_pvt_GPIB_INIT_flag)// NOT initialised
		   {
              INT_OK=Generate_Device_Control_pntr();//Atttempt initilisation
		   }

		   if (0XFF!=_pvt_GPIB_INIT_flag)//STILL NOT INItialised
		   {
             _pvt_Report_GPIB_interface_parameters();
			 return 99999;//ERROR
		   }
		   //********** TEST FOR INITILISATION *****************


           ibwrt(_pvt_NI_GPIB_device_ID_pntr, GPIB_message_char_array, Number_of_chars_in_message);

		   Number_of_chars_in_message = (unsigned int) (ibcnt);


		   return ibsta;// Bus status Se NI488

	   };//END unsigned long  IEEE_488_GPIB_manager::Transmitt_a_char_array_to_GPIB(char GPIB_message_char_array[], int Number_of_chars_in_message)




	   
      /***************** Receive_a_char_array_from_GPIB *****************


	  Entity:                      I/O condition: Explanation:

	  "GPIB_message_char_array"    Input         THe MAXIMUN number of
	                                           chars that you want from 
											   GPIB.

      "Number_of_chars_in_message" INPUT       The maximum number of chars 
	                                          that you expect to be placed in 
	                                          "GPIB_message_char_array"   
	   
	  "Number_of_chars_in_message" OUTPUT      The number of chars 
	                                           actually extracted from GPIB.  
	                                                
      WARNING!!! " GPIB_message_char_array" MUST beable accomadate at least
	               256 chars!!!!  256 chars is the default minimum.

	  ****************** _____________________________ *********************/
		  

	      unsigned long  IEEE_488_GPIB_manager::Receive_a_char_array_from_GPIB(char GPIB_message_char_array[], unsigned int &Number_of_chars_in_message)
	   {

		   int INT_OK;

		   //********** TEST FOR INITILISATION *****************
		   if (0XFF!=_pvt_GPIB_INIT_flag)// NOT initialised
		   {
              INT_OK=Generate_Device_Control_pntr();//Atttempt initilisation
		   }

		   if (0XFF!=_pvt_GPIB_INIT_flag)//STILL NOT INItialised
		   {
             _pvt_Report_GPIB_interface_parameters();
			 return 999999;//ERROR
		   }
		   //********** TEST FOR INITILISATION *****************

		     if (256>Number_of_chars_in_message)
			 {
				 Number_of_chars_in_message =256;
			 }



              ibrd(_pvt_NI_GPIB_device_ID_pntr, GPIB_message_char_array, Number_of_chars_in_message);// Read  upto 250 chars
             /* Read up to 250 bytes from the device    */

             Number_of_chars_in_message = (unsigned int) ibcntl;
             GPIB_message_char_array[ibcntl] = '\0'; /* Null terminate the ASCII string         */



		   return ibsta;// Bus status Se NI488

	   };//unsigned long  IEEE_488_GPIB_manager::Receive_a_char_array_from_GPIB(char GPIB_message_char_array[], int &Number_of_chars_in_message)



	  unsigned char IEEE_488_GPIB_manager::Report_avalible_GPIB_interfaces()
	  {

         //************************* Begin Varible Definitions *************************
         // boolean Varibles
         bool          Valid_GPIB_Interface_found;    // Indicates that valid equipment was found
		 bool          Valid_SCPI_GPIB_Interface_found;    // Indicates that valid equipment was found

         // char  varibles
         char          GPIB_reply_array[define_256_chars]; /* Read GPIB_reply_array*/ 
		 char          Bell_Array[define_256_chars]; 												   
														   
		 unsigned char Reply_Message;// =0X00 if functino exist OK
		

         //interger varibles
         int           GPIB_Device_Identifier = 0;/* Device unit descriptor                  */
         int           Board_Index = 0;           /* Interface Index (GPIB0=0,GPIB1=1,etc.)  */
         int           PrimaryAddress = 12;       /* Primary address of the device           */
         int           SecondaryAddress = 0;      /* Secondary address of the device         */
         int           Board_Index_loop;          // for loop varible 
         int           PrimaryAddress_loop;       // for loop varible
         int           SecondaryAddress_loop;     // for loop varible
         unsigned char Valid_board_index_detected[16];           

         // IO vasribles 
        
		 errno_t       File_Open_Error;             // Magical varible: Abra Cadabra

         //****************** End Varible Definitions************************************

          
       
           Bell_Array[0]=(char) 7;//Bell
		   Bell_Array[1]=(char) 7;//Bell
		   Bell_Array[2]=(char) 7;//Bell
		   Bell_Array[3]='\0';//Bell
		   system("del Avalible_GPIB_Interface_Report.txt ");
		 
		   

		  File_Open_Error = fopen_s(&_pvt_Interface_Report_FILE_pntr,"Avalible_GPIB_Interface_Report.txt", "w+"); 

	      Reply_Message =0X00;//All OK so far...
		  if( (NULL==_pvt_Interface_Report_FILE_pntr) ||(File_Open_Error!=0)) //
		  {
			_pvt_char_YN ='n';
			while ('y'!= _pvt_char_YN)
			{
             printf("********* ERROR_ALERT *** ERROR_ALERT *** ERROR_ALERT  ************\n");
		     printf("*                                                                 *\n");
		     printf("*         ''_pvt_Interface_Report_FILE_pntr'' is NULL!!             *\n");
		     printf("*                                                                 *\n");
		     printf("* ''Report_avalible_GPIB_interfaces'' reported this error.       *\n");
		     printf("*                                                                 *\n");
			 printf("*  THere is an abandoned file pointer that must be killed with a  *\n");
			 printf("* ''computer restart''.  This must be done at the command prompt. *\n");
			 printf("*                                                                 *\n");
		     printf("*           ''IEEE_488_GPIB_manager'' will now puke on you.          **\n");
		     printf("********* ___________ *** ___________ *** ___________  ************\n");
             printf("Type 'y' to acknowlege this message......"); 
		     _pvt_char_YN = (char)getchar();
			 return -1;
			 }

             Reply_Message = 0X01;//ERROR alert
			 return Reply_Message;
		  }
		  fclose(_pvt_Interface_Report_FILE_pntr);

 
   Valid_board_index_detected[0]=0X00;
   Valid_board_index_detected[1]=0X00;
   Valid_board_index_detected[2]=0X00;

  for (Board_Index_loop=0; Board_Index_loop<4; Board_Index_loop++)
  {
	Board_Index=Board_Index_loop;
	

	for (PrimaryAddress_loop=0; PrimaryAddress_loop<32; PrimaryAddress_loop++)
	{
       PrimaryAddress=PrimaryAddress_loop;//
	
		
		for (SecondaryAddress_loop=0;SecondaryAddress_loop<1;SecondaryAddress_loop++ )
		{
			SecondaryAddress=SecondaryAddress_loop;

			system("cls");
			printf("Board_Index=%i\n",Board_Index);
			printf("PrimaryAddress_loop=%i\n",PrimaryAddress_loop);
			printf("SecondaryAddress=%i\n",SecondaryAddress);
			
			

		    Valid_GPIB_Interface_found=true; 

		    /*****************************************************************************
	 	    * Initialization - Done only once at the beginning of your application.
		    *****************************************************************************/

		  

		    GPIB_Device_Identifier = ibdev(/* Create a unit descriptor handle         */
            Board_Index ,                  /* Board Index (GPIB0 = 0, GPIB1 = 1, ...) */
            PrimaryAddress,                /* Device primary address                  */
            SecondaryAddress,              /* Device secondary address                */
            T300ms,                        /* Timeout setting (T300ms =0p300 seconds) */
            1,                             /* Assert EOI line at end of write         */
            0);                            /* EOS termination mode                    */
		 
		  
			if ((0X00==Valid_board_index_detected[Board_Index_loop])&&(256==ibsta))
			{
               Valid_board_index_detected[Board_Index_loop]=0XFF;
               printf("Board_Index      = %i is valid \n",Board_Index);
			   Sleep(1000);

			   File_Open_Error = fopen_s(&_pvt_Interface_Report_FILE_pntr,"Avalible_GPIB_Interface_Report.txt", "a"); 
			   fprintf(_pvt_Interface_Report_FILE_pntr,"Board_Index     = %i is valid \n\n\n",Board_Index);
			  
               fclose(_pvt_Interface_Report_FILE_pntr);

			}
		

			   printf("Board_Index      = %i \n",Board_Index);
			   printf("PrimaryAddress   = %i \n",PrimaryAddress);
			   printf("SecondaryAddress = %i \n",SecondaryAddress);
		       printf("ibsta            = %i \n\n\n",ibsta);//GPIB_Device_Identifier           
		      // getchar();
		  
			 
              //** TEST FOR VALID GPIB INTERFACE  ****************
		      
			   
			   ibwrt(GPIB_Device_Identifier, "junk_message\0", 8);           // Send the identification query command
              
			  Valid_GPIB_Interface_found =true;
		      if (ibsta & ERR) // Check for GPIB Error 
		      {

			   _pvt_Display_NI488_Error_Codes(GPIB_Device_Identifier );
			   Valid_GPIB_Interface_found =false;
		     }else
			  {
			  

			 }
			 

			  //************    TEST FOR  SCPI interface ******************
			  ibrd(GPIB_Device_Identifier, GPIB_reply_array, 100); /* Read up to 100 bytes from the device    */
			  GPIB_reply_array[ibcntl] = '\0';                     /* Null terminate the ASCII string         */
			  if (0!=ibcntl)
			  {
				  Valid_SCPI_GPIB_Interface_found =true;
			  }else
			  {
				  Valid_SCPI_GPIB_Interface_found = false;
			  }

			   

                system("cls");


			 

			  if (true==Valid_GPIB_Interface_found)
			  {
                 


               File_Open_Error = fopen_s(&_pvt_Interface_Report_FILE_pntr,"Avalible_GPIB_Interface_Report.txt", "a"); 

			   fprintf(_pvt_Interface_Report_FILE_pntr,"Instrument detected \n",Board_Index);
			   fprintf(_pvt_Interface_Report_FILE_pntr,"Board_Index     = %i \n",Board_Index);
			   fprintf(_pvt_Interface_Report_FILE_pntr,"PrimaryAddress  = %i \n",PrimaryAddress);
			   fprintf(_pvt_Interface_Report_FILE_pntr,"SecondaryAddress= %i \n\n",SecondaryAddress);
               fclose(_pvt_Interface_Report_FILE_pntr);
			  
			   
			   printf("Board_Index= %i \n",Board_Index);
			   printf("PrimaryAddress= %i \n",PrimaryAddress);
			   printf("SecondaryAddress= %i \n\n\n",SecondaryAddress);
			   

			  };//END  if (true==Valid_GPIB_Interface_found)


		
			  ibclr(GPIB_Device_Identifier);                 /* Clear the device */
     
	
	
		  /*****************************************************************************
		  * Uninitialization - Done only once at the end of your application.
		  *****************************************************************************/

		  ibonl(GPIB_Device_Identifier, 0);              /* Take the device offline                 */
		  if (ibsta & ERR) 
		  {
			 _pvt_Display_NI488_Error_Codes(GPIB_Device_Identifier );
		  }


		}// END SecondaryAddress_loop

	}//END  PrimaryAddress_loop


  }// END Board_Index_loop


    fclose(_pvt_Interface_Report_FILE_pntr);




		system("Avalible_GPIB_Interface_Report.txt");
	



       return Reply_Message;
	  };//END unsigned char IEEE_488_GPIB_manager::Report_avalible_GPIB_interfaces(bool DISPLAY_Product_file)



 int IEEE_488_GPIB_manager::Generate_Device_Control_pntr(void)
	 {
       int Reply_message=0;//

        if (0>GPIB_Board_Index)
		{
			_pvt_char_YN = 'n';

			while ('y'!= _pvt_char_YN)
			{
			system("cls");
			printf("**** ERROR ALERT ERROR ALERT ERROR ALERT *******\n");
			printf("*                                             **\n");
			printf("* ''GPIB_Board_Index'' is not a valid value!  **\n");
			printf("*                                             **\n");
			printf("*   ''IEEE_488_GPIB_manager'' will now puke.     **\n");
			printf("*                                             **\n");
			printf("** _______________________________________ *****\n\n\n");

		     printf("Type 'y' to acknowlege this message......"); 
			 _pvt_char_YN = (char)getchar();
			}
			 return -1;
		
		}


		  if (0>GPIB_Primary_Address)
		{

			_pvt_char_YN = 'n';

			while ('y'!= _pvt_char_YN)
			{
			system("cls");
			printf("**       ERROR ALERT ERROR ALERT ERROR ALERT      ***\n");
			printf("*                                                  **\n");
			printf("*  ''GPIB_Primary_Address'' is not a valid value!  **\n");
			printf("*                                                  **\n");
			printf("*       ''IEEE_488_GPIB_manager'' will now puke.      **\n");
			printf("*                                                  **\n");
			printf("** ____________________________________________ *****\n\n\n");

		     printf("Type 'y' to acknowlege this message......"); 
			 _pvt_char_YN = (char)getchar();
			}
			 
		   return -2;
		}


		  if (0>GPIB_Secondary_Address)
		{
            _pvt_char_YN = 'n';
			while ('y'!= _pvt_char_YN)
			{
			system("cls");
			printf("**        ERROR ALERT ERROR ALERT ERROR ALERT       ***\n");
			printf("*                                                    **\n");
			printf("*  ''GPIB_Secondary_Address'' is not a valid value!  **\n");
			printf("*                                                    **\n");
			printf("*       ''IEEE_488_GPIB_manager'' will now puke.        **\n");
			printf("*                                                    **\n");
			printf("** ______________________________________________ *****\n\n\n");

		     printf("Type 'y' to acknowlege this message......"); 
			 _pvt_char_YN = (char)getchar();
			}
			 return -3;
		  }



		  
    /******************************************************************************
    * Initialization - Done only once at the beginning of your application.
    ******************************************************************************/

    _pvt_NI_GPIB_device_ID_pntr = ibdev( /* Create a unit descriptor handle         */       
    GPIB_Board_Index ,                   /* Board Index (GPIB0 = 0, GPIB1 = 1, ...) */  
    GPIB_Primary_Address,                /* Device primary address                  */                
    GPIB_Secondary_Address,              /* Device secondary address                */                 
    T10s,                                /* Timeout setting (T10s = 10 seconds)     */     
    1,                                   /* Assert EOI line at end of write         */       
    0);                                  /* EOS termination mode                    */             
		 

    ibclr(_pvt_NI_GPIB_device_ID_pntr);            //* Clear the device  

	_pvt_GPIB_INIT_flag =0XFF;// GPIB BUS ready for use.

      return 0;
	 };//END int IEEE_488_GPIB_manager::Generate_Device_Control_pntr(void)




 
      IEEE_488_GPIB_manager::~IEEE_488_GPIB_manager()//Destructor
	 {
           /* Call ibonl to take the device and interface offline */



	 };//END  IEEE_488_GPIB_manager::~IEEE_488_GPIB_manager()//Destructor



#endif




/************* LEGAL CYA ************************************************
	
1)  (I/we/us) make no expressed warranties or implied warranties 
   what-so-ever on the fitness or merchantability of this software for 
   any purpose.

2)   By using this software, you accept any and all liability and risk 
   associated with the use of this software.

3)  This software may NEVER be used in any shape form or 
    fashion that will result in: 
   
    A) Personal injury
    B) Economic damage
    C) Criminal activity
    D) Any circumstance that might enable a plaintifs lawyer to
	   sue (I/we/us) for criminal or civil penalties.

       
4)  Any use of this software is contingent on the indisputable fact 
   that anyone who uses this software accepts this software "AS-IS".

5)  Any re-transmission of this software MUST contain ALL of the 
   legal CYA text in the original unaltered form.  
************* LEGAL CYA *************************************************/