/*****************  engineering_file_IO_transcription_class ********************

	This class is intended for data aqusition. Specifically, there are 
plenty of cases where I want to interrupt an experiment at an arbitrary
point in time.

     If you do do not explicitly close the file pointer (ofstream,STDIO)
you are at the mercy of the operating system.  Sometimes your data is 
written, sometimes not.  

 This class reduces the probability that you data will be lost when you
exit at an arbitrary time in execution.  Typically only a line or two of
data are lost.

 Also, you are not obligated to explicitly "close" the file pointer. 
This task is performed after each and every "write".

********************  ________________________ *************************/
#include <iostream>
#include <cstdio>
#include <cstring>



#ifndef  define_256_chars
#define  define_256_chars (256)
#endif 


#ifndef _engineering_file_transcription_class_dot_h_
#define _engineering_file_transcription_class_dot_h_


#pragma message("\n *********** ------------------------- ***********************\n")
#pragma message("\n **   _engineering_file_transcription_class_dot_h_           *\n")
#pragma message("\n **                June, 27, 2018                            *\n")
#pragma message("\n *********** _________________________ ***********************\n")
#pragma message("\n \n \n")



class engineering_file_IO_transcription_class
{  



public:

   engineering_file_IO_transcription_class();
   ~engineering_file_IO_transcription_class();

   unsigned char   file_pointer_create          (char   FILE_name_char_array[]);
   unsigned char   transcribe_float_to_file     (float  float_varible);
   unsigned char   transcribe_double_to_file    (double double_varible);
   unsigned char   transcribe_int_to_file       (int    int_varible);
   unsigned char   transcribe_char_array_to_file(char   char_array[]);
   unsigned char   transcribe_newline_to_file   ();
   unsigned char   transcribe_comma_to_file     ();


 private:

	FILE          *_pvt_Engineering_file_writer;     // Writes the engineering
	                                                 // file.

	unsigned char _pvt_File_open_status;             // Reports the sucess
	                                                 //  of the  opened file.  
	                                                 // File opened OK.

	char          _pvt_Reserved_File_Name_Array[1000];
	                                                 // local preserved name
	                                                 // of Desired file name
	errno_t       _pvt_File_Open_Error;              // Magical file entity.

	unsigned char _pvt_File_Opened_Sucessfully;      // 0X00 if false 
	                                                 // !=0X00 if true    
    void          ERROR_notification_message();


/********************  ____  74 chars ________ *************************/








};//END class engineering_file_IO_transcription_class






























 void engineering_file_IO_transcription_class::ERROR_notification_message()
	{
          
     printf("*************__ERROR_ALERT__**********************\n");
     printf("*                                                *\n");
	 printf("*     The file entity has not been created!!!    *\n");
	 printf("*                                                *\n");
	 printf("*       NO file writes are possible.             *\n");
	 printf("*                                                *\n");
	 printf("*                                                *\n");
	 printf("*''__pvt_Engineering_File_Writer_IO_class_dot_h_''*\n");
	 printf("*            REPORTED THIS ERROR                 *\n");
	 printf("*                                                *\n");
	 printf("*************_______________**********************\n");
		 	
	 getchar();
		
	};//END  ERROR_notification_message()



 	   /************** file_pointer_create( char FILE_name_char_array[]) *****************
       Opens a file named "FILE_name_char_array[]" 

	   Varibble Name:         Translation:
	   "FILE_name_char_array[]"    Name of file that you want to open.
	                          The file name must be NULL terminated.


		"Return_Message"      Returns 0X00 when the desired file opened. 
		                      without problems, otherwise, ERROR.

	   **************** __________________________________ ***************/


unsigned char engineering_file_IO_transcription_class::file_pointer_create( char FILE_name_char_array[])
{
  unsigned char Return_Message;// 

   Return_Message =0X00;// So far so good.

   strncpy_s(_pvt_Reserved_File_Name_Array,FILE_name_char_array,(sizeof(_pvt_Reserved_File_Name_Array)-1));
      
   _pvt_File_Open_Error = fopen_s(&_pvt_Engineering_file_writer,_pvt_Reserved_File_Name_Array, "w"); 


		  if ((NULL==_pvt_Engineering_file_writer)||(0!=_pvt_File_Open_Error))
		  {
			ERROR_notification_message();
			Return_Message =0X01;//Error Message
			_pvt_File_open_status = 0X01;
			return Return_Message;
		  }
		  //fflush(_pvt_Engineering_file_writer);
          fclose(_pvt_Engineering_file_writer);
		 
          _pvt_File_open_status = 0X00;//  
		  _pvt_File_Opened_Sucessfully =0XFF;
          
          return Return_Message;

 };// END engineering_file_IO_transcription_class::file_pointer_create( char FILE_.......


 /********************  transcribe_float_to_file **************************

 Writes a float to the engineering file.  The format of the float is

 "%E" The mantissia and the ordinate are ALWAYS reported.

 Entity:               Translation:
 
 float_varible          The varible that you want reported.
	   
 Return_Message        Returns 0X00 if the file write worked.

********************  __________________ ***************************/




unsigned char engineering_file_IO_transcription_class::transcribe_float_to_file(float float_varible)
{
  
  unsigned char Return_Message =0X00;

		  		
  if (0X00!=_pvt_File_open_status)
  {
   ERROR_notification_message();
   Return_Message =0X01;//Error Message
   return Return_Message;
   }

   _pvt_File_Open_Error = fopen_s(&_pvt_Engineering_file_writer,_pvt_Reserved_File_Name_Array,"a");

	while (13==_pvt_File_Open_Error)
	{

       _pvt_File_Open_Error = fopen_s(&_pvt_Engineering_file_writer,_pvt_Reserved_File_Name_Array,"a");
	   fprintf(stderr,"''engineering_file_IO_transcription_class'' waits for operating system priveleges \n");
	   

	 
	}

   if ((NULL==_pvt_Engineering_file_writer)||(0!=_pvt_File_Open_Error))
   {
    ERROR_notification_message();
	Return_Message =0X01;//Error Message
    _pvt_File_open_status = 0X01;
	return Return_Message;
	}







    fprintf(_pvt_Engineering_file_writer,"%E",float_varible);
	fflush(_pvt_Engineering_file_writer);
	fclose(_pvt_Engineering_file_writer);

	return Return_Message;

};//END  engineering_file_IO_transcription_class::transcribe_float_to_file(float..



/*******************  transcribe_double_to_file **************************

Writes a float to the engineering file.  The format of the float is

 "%E" The mantissia and the ordinate are ALWAYS reported.

 Varible:               Translation:
 double_varible         The varible that you want reported.
	   
 Return_Message        Returns 0X00 if the file write worked.

******************  __________________ ******************************/



unsigned char engineering_file_IO_transcription_class::transcribe_double_to_file(double double_varible)
{
  unsigned char Return_Message=0X00;
     
   if (0X00!=_pvt_File_open_status)
   {
    ERROR_notification_message();
	Return_Message =0X01;//Error Message
	return Return_Message;
   }
		 
    _pvt_File_Open_Error= fopen_s(&_pvt_Engineering_file_writer, _pvt_Reserved_File_Name_Array, "a");

		while (13==_pvt_File_Open_Error)
	{

       _pvt_File_Open_Error = fopen_s(&_pvt_Engineering_file_writer,_pvt_Reserved_File_Name_Array,"a");
	  fprintf(stderr,"''engineering_file_IO_transcription_class'' waits for operating system priveleges \n");
	   

	   
	}


    if ((NULL==_pvt_Engineering_file_writer)||(0!=_pvt_File_Open_Error))
    {
	 ERROR_notification_message();
	 Return_Message =0X01;//Error Message
	 _pvt_File_open_status = 0X01;
	 return Return_Message;
	}

    fprintf(_pvt_Engineering_file_writer,"%E",double_varible);
	fflush(_pvt_Engineering_file_writer);
	fclose(_pvt_Engineering_file_writer);

	return Return_Message;
	
 };//END  engineering_file_IO_transcription_class::transcribe_double_to_file(..




/*********************  transcribe_int_to_file ******************************

 Writes a float to the engineering file.  The format of the float is

 "%E" The mantissia and the ordinate are ALWAYS reported.

  Varible:          Translation:
	   
  int_varible        The varible that you want reported.	   
  Return_Message     Returns 0X00 if the file write worked.

********************  __________________ *******************************/

unsigned char engineering_file_IO_transcription_class::transcribe_int_to_file(int int_varible)
{
 
   unsigned char Return_Message;
     
   if (0X00!=_pvt_File_open_status)
   {
     ERROR_notification_message();
	 Return_Message =0X01;//Error Message
	 return Return_Message;
	}
		 
   Return_Message = 0X00;

   _pvt_File_Open_Error = fopen_s(&_pvt_Engineering_file_writer, _pvt_Reserved_File_Name_Array, "a");

   	while (13==_pvt_File_Open_Error)
	{

       _pvt_File_Open_Error = fopen_s(&_pvt_Engineering_file_writer,_pvt_Reserved_File_Name_Array,"a");
	  fprintf(stderr,"''engineering_file_IO_transcription_class'' waits for operating system priveleges \n");
	   
	 
	}



  

   if ((NULL==_pvt_Engineering_file_writer)||(0!=_pvt_File_Open_Error))
   {
	 ERROR_notification_message();
	 Return_Message =0X01;//Error Message
	 _pvt_File_open_status = 0X01;
	
	 return Return_Message;
	}


    fprintf(_pvt_Engineering_file_writer,"%i",int_varible);
	fflush(_pvt_Engineering_file_writer);
    fclose(_pvt_Engineering_file_writer);


	return Return_Message;

};//END  unsigned char engineering_file_IO_transcription_class::transcribe_int_to_file(int..



unsigned char engineering_file_IO_transcription_class::transcribe_char_array_to_file(char char_array[])
{
  unsigned char Return_Message;
     
  if (0X00!=_pvt_File_open_status)
  {
    ERROR_notification_message();
	Return_Message =0X01;//Error Message
	return Return_Message;
  }

  Return_Message =0X00;

  _pvt_File_Open_Error= fopen_s(&_pvt_Engineering_file_writer, _pvt_Reserved_File_Name_Array, "a");

  	while (13==_pvt_File_Open_Error)
	{

       _pvt_File_Open_Error = fopen_s(&_pvt_Engineering_file_writer,_pvt_Reserved_File_Name_Array,"a");
	   fprintf(stderr,"''engineering_file_IO_transcription_class'' waits for operating system priveleges \n");
	   

	
	}


  if ((NULL==_pvt_Engineering_file_writer)||(0!=_pvt_File_Open_Error))
  {
	ERROR_notification_message();
	Return_Message =0X01;//Error Message
	_pvt_File_open_status = 0X01;
	return Return_Message;
  }

  fprintf(_pvt_Engineering_file_writer,"%s",char_array);
  fflush(_pvt_Engineering_file_writer);
  fclose(_pvt_Engineering_file_writer);

   return Return_Message;

  };//END engineering_file_IO_transcription_class::transcribe_char_array_to_file(char...




/**********************  transcribe_newline_to_file **************************

Writes a "new_line"(char(10))to the engineering file.  
	
Return_Message        Returns 0X00 if the file write worked.


***********************  __________________ *****************************/

unsigned char engineering_file_IO_transcription_class::transcribe_newline_to_file()
{
   unsigned char Return_Message =0X00;
		  		
   if (0X00!=_pvt_File_open_status)
   {
     ERROR_notification_message();
	 Return_Message =0X01;//Error Message
	 return Return_Message;
	}


   _pvt_File_Open_Error= fopen_s(&_pvt_Engineering_file_writer, _pvt_Reserved_File_Name_Array, "a");


   	while (13==_pvt_File_Open_Error)
	{

       _pvt_File_Open_Error = fopen_s(&_pvt_Engineering_file_writer,_pvt_Reserved_File_Name_Array,"a");
	   fprintf(stderr,"''engineering_file_IO_transcription_class'' waits for operating system priveleges \n");
	   

	  
	}


   if ((NULL==_pvt_Engineering_file_writer)||(0!=_pvt_File_Open_Error))
   {
	ERROR_notification_message();
	Return_Message =0X01;//Error Message
	_pvt_File_open_status = 0X01;
	return Return_Message;
   }
		 


    fprintf(_pvt_Engineering_file_writer,"\n");
	fflush(_pvt_Engineering_file_writer);
    fclose(_pvt_Engineering_file_writer);

    return Return_Message;

 };//END  unsigned char engineering_file_IO_transcription_class::transcribe_newline_to_file()







 /**********************  transcribe_comma_to_file **************************

 Writes a comma(',')to the engineering file.  The format of the float is
	
 Return_Message        Returns 0X00 if the file write worked.


 ********************  __________________ ******************************/

unsigned char engineering_file_IO_transcription_class::transcribe_comma_to_file()
{
   unsigned char Return_Message =0X00;
  		
   if (0X00!=_pvt_File_open_status)
	{
      ERROR_notification_message();
	  Return_Message =0X01;//Error Message
	   return Return_Message;
     }


	_pvt_File_Open_Error= fopen_s(&_pvt_Engineering_file_writer, _pvt_Reserved_File_Name_Array, "a");

		while (13==_pvt_File_Open_Error)
	{

       _pvt_File_Open_Error = fopen_s(&_pvt_Engineering_file_writer,_pvt_Reserved_File_Name_Array,"a");
	   fprintf(stderr,"''engineering_file_IO_transcription_class'' waits for operating system priveleges \n");
	   

	 

	  
	}


	if ((NULL==_pvt_Engineering_file_writer)||(0!=_pvt_File_Open_Error))
	{
	  ERROR_notification_message();
	  Return_Message =0X01;//Error Message
	  _pvt_File_open_status = 0X01;
	  return Return_Message;
	 }

     fprintf(_pvt_Engineering_file_writer,",");
	 fflush(_pvt_Engineering_file_writer);
	 fclose(_pvt_Engineering_file_writer);

	 return Return_Message;

 };//END engineering_file_IO_transcription_class::transcribe_comma_to_file()



engineering_file_IO_transcription_class::engineering_file_IO_transcription_class()
{
  _pvt_File_open_status = 0X01;// Used in testing the file I/O entity
  strcpy_s(_pvt_Reserved_File_Name_Array,define_256_chars,"  ");
  _pvt_File_Opened_Sucessfully = 0X00;// detects the first time that 
		                         // a file is opened sucessfully 
};//END engineering_file_IO_transcription_class() 
	

     
 engineering_file_IO_transcription_class::~engineering_file_IO_transcription_class()
 {
  if ((NULL!=_pvt_Engineering_file_writer)&&(0X00!=_pvt_File_Opened_Sucessfully))
  {//Means file pointer is open
   fflush(_pvt_Engineering_file_writer);
   fclose(_pvt_Engineering_file_writer);// Garbage collection
   }
 }


#endif