
/*********  READ ME     READ ME    READ ME    READ ME    READ ME  **********

  If you experience troubles, then try plotting your data in Microsoft 
Excel (or equivelent software). Your data may be exceedingly erratic for 
the simplistic interpretation provided by  "line_fit_magic_dot_h". 

Stability dictates minimum requirements for your data

Equation order:  Minimum number of data pairs:
    0                3
    1                4
    2                5
    3                6
    4                7
    5                8

	Alter these requirements at you own risk.

*********    READ ME    READ ME    READ ME    READ ME    READ ME    **********/

#ifndef _CRT_SECURE_NO_WARNINGS 
#define _CRT_SECURE_NO_WARNINGS
#pragma message("\n ************* ------------------------- ***********************  \n")
#pragma message("\n **    COMPILER WARNING FUNCTION DEACTIVATED                   *  \n")
#pragma message("\n **              January, 2, 2014                              *  \n")
#pragma message("\n ************* _________________________ ***********************  \n \n \n")
#endif




#include "stdio.h"
#include "math.h"
#ifndef _line_fit_magic_dot_h_
#define _line_fit_magic_dot_h_

#pragma message("\n ************* ------------------------- ***********************  \n")
#pragma message("\n **              line_fit_magic_dot_h                          *  \n")
#pragma message("\n **               January  03, 2019                            *  \n")
#pragma message("\n ************* _________________________ ***********************  \n \n \n")



/***************  line_fit_magic_nth_order_polynomial_results ***********

  "line_fit_magic_nth_order_polynomial_results"  reports your results.

 
 "line_fit_magic_nth_order_polynomial_results" Product coefficients
 Entity:                                       Explanation:          

  line_fit_magic_nth_order_polynomial_results[0]     (a) as in  a*(X^0)
  line_fit_magic_nth_order_polynomial_results[1]     (b) as in  b*(X^1)
  line_fit_magic_nth_order_polynomial_results[2]     (c) as in  c*(X^2)
  line_fit_magic_nth_order_polynomial_results[3]     (d) as in  d*(X^3)
  line_fit_magic_nth_order_polynomial_results[4]     (e) as in  e*(X^4)
  line_fit_magic_nth_order_polynomial_results[5]     (f) as in  f*(X^5)

  Y = f*(X^5)+e*(X^4)+d*(X^3)+c*(X^2)+b*(X^1)+a*(X^0);


  If you request  a polynomial of less than 5 for your results,then the 
remaining coefficients become zero.

Example : you request a polynomial of highest order "3"

coefficeints "e" and "f" are 0.000. 


*************  __________________________________________ **************/
double line_fit_magic_nth_order_polynomial_results[16];//





/************ line_fit_magic_generate_nth_order_polynomial **************

Basic usage:

  1) You have an array of X and y data generated form an experiment. 
  2) You also need to calculate the coefficients of a best fit 
     "nth" order polynomial.(n=0,1,..,5)
  3) Excel is not convienent or avalible.

  Entity:                        Translation:

  "number_of_data_pairs"         Number of data pairs from an experiment
  "Y_value_data_cpy"             data from experiment(observed)
  "X_value_data_cpy"             data from experiment(controlled)
  
  "us_char_degree_of_polynomial" order of desired polynomial (<6 allowed)


  Warning:  You are limited to 256 data pairs. Really, if you need  an 
 equation line for more than 256 data pairs, then either use MS excel
 or consult a mental health professional.


   The return value represents a realtive "fitness" of the resulting 
 polynomial. Ideally the returned value is zero.  As a practical matter,
 when the returned value also conveys an error message.  If the returned
 value is < 0.00, an error occured. 


 Your results are conveyed by:


 "line_fit_magic_nth_order_polynomial_results"


 I only optimised to code for a 5th order polynomial. Higher order
 polynomials might be possible.  If you decide to edit the code then 
 beaware of the following:

 1) DO NOT remove initilisations
 2) DO NOT remove "zero" tests.

  For what ever reasons the stability of  "line_fit_magic_generate_nth_order_polynomial"
 absolutely requires the above described steps. 

*************** __________________________________ *********************/
double line_fit_magic_generate_nth_order_polynomial(unsigned int number_of_data_pairs, double Y_value_data_cpy[], double X_value_data_cpy[],  unsigned char us_char_degree_of_polynomial);



double line_fit_magic_generate_nth_order_polynomial(unsigned int number_of_data_pairs, double Y_value_data[], double X_value_data[], unsigned char us_char_degree_of_polynomial)
{


   long double Y_sigma_sum_array[512];   
   long double X_sigma_sum_array[512];
   long double X_value_data_cpy[512];
   long double Y_value_data_cpy[512];

  
   long double Augmented_mystery_matrix [300][300];//  big enough?


   long double Single_item_from_mystery_matrix;   
   long double Numeric_lower_limit;
   long double Numeric_copy_of_long_double;
   long double _5th_order_COEFF;
   long double _4th_order_COEFF;
   long double _3rd_order_COEFF;
   long double _2nd_order_COEFF;
   long double _1st_order_COEFF;
   long double _0th_order_COEFF;
   long double ACTUAL_value_of_Y;
   long double Calculated_value_of_Y;
   long double Y_actual_minus_Y_calculated;


   double      X_pow_0;// X^0 (always 1)
   double      X_pow_1;// X^1
   double      X_pow_2;// X^2
   double      X_pow_3;// X^3
   double      X_pow_4;// X^4
   double      X_pow_5;// X^5

    double      evanescent_copy;

  
   double       value_of_X; 
   long double  Y_actual_minus_Y_calculated_squared;          
   long double  SUM_of_Y_actual_minus_Y_calculated_squared;
   double       SUM_of_Y_actual_minus_Y_calculated_squared_double;
   double       SUM_of_Y_actual_minus_Y_calculated_ABS;
   double       average_of_Y_actual_minus_Y_calculated_ABS;
   double       Number_of_points_double_format;
       

   int          index_i;
   int          index_j;
   int          index_k;
   int          degree_of_polynomial;
   int          Minimum_required_data_pairs;
   unsigned int number_of_data_pairs_cpy;

  



  
   /*  WARNING!   WARNING!   WARNING!   WARNING!   WARNING!   WARNING! 

   Stability absolutely  requires initialisation of 
   "line_fit_magic_nth_order_polynomial_results" with a value of "0.0000000"!!

   DO NOT omit the following loop.  I never found root cause.

     WARNING!   WARNING!   WARNING!   WARNING!   WARNING!   WARNING! */
  
	 
   for (index_i=0;index_i<16;index_i++)
   {

	    line_fit_magic_nth_order_polynomial_results[index_i]=0.000000;;//

   }

  

     /*  WARNING!   WARNING!   WARNING!   WARNING!   WARNING!   WARNING! 

     Stability absolutely  requires  a definition of "zero" 
    DO NOT remove any of the "zero" tests I never found root cause.
  
     WARNING!   WARNING!   WARNING!   WARNING!   WARNING!   WARNING! */


   Numeric_lower_limit = (long double)pow(10,-28.00); // 1.00E-28 anything smaller is zero

  

	if (256<number_of_data_pairs)
	{

		fprintf(stderr,"******************** FUMTU ALERT ******************************\n");
		fprintf(stderr,"*                                                             *\n");
		fprintf(stderr,"* ''line_fit_magic_generate_nth_order_polynomial'' can only accomadate  *\n");
		fprintf(stderr,"* upto a 256 data pairs!                                      *\n");
		fprintf(stderr,"* You requested a equation for %i data pairs.                  \n",number_of_data_pairs);
		fprintf(stderr,"*                                                             *\n");
		fprintf(stderr,"******************** FUMTU ALERT ******************************\n\n\n");

	    fprintf(stderr,"Tap any key to exit.........*\n");
	    getchar();

		return -1.00;

	}



	 for (index_i=0;index_i<number_of_data_pairs;index_i++)
   {

	   X_value_data_cpy[index_i]=X_value_data[index_i];
	   Y_value_data_cpy[index_i]=Y_value_data[index_i];

   }

     number_of_data_pairs_cpy = number_of_data_pairs;



  
	if (5<us_char_degree_of_polynomial)
	{

		fprintf(stderr,"**************************  FUMTU ALERT ********************************\n");
		fprintf(stderr,"*                                                                      *\n");
		fprintf(stderr,"* ''line_fit_magic_generate_nth_order_polynomial'' can only accomadate *\n");
		fprintf(stderr,"* upto a 5th order polynomial!!                                        *\n");
		fprintf(stderr,"* You requested a %i order polynomial.                                  \n",us_char_degree_of_polynomial);
		fprintf(stderr,"*                                                                      *\n");
		fprintf(stderr,"************************  FUMTU ALERT **********************************\n\n\n");

	    fprintf(stderr,"Tap any key to exit.........*\n");
	    getchar();

		return -2.00;

	}

	/*

	   Must test for specialised case where the degree of the requested  polynomial is zero.
	   Some the code may be non stable with a zero order polynomial. 

	*/



	if (0==us_char_degree_of_polynomial)
	{
		 line_fit_magic_nth_order_polynomial_results[0]=0.0000;

		for (index_i=0;index_i<number_of_data_pairs;index_i++)
		{
              line_fit_magic_nth_order_polynomial_results[0]=  line_fit_magic_nth_order_polynomial_results[0] + Y_value_data[index_i];
		}

		line_fit_magic_nth_order_polynomial_results[0] = line_fit_magic_nth_order_polynomial_results[0]/((double)number_of_data_pairs);

	}

   
	degree_of_polynomial=(int)us_char_degree_of_polynomial;





	Minimum_required_data_pairs =((int)us_char_degree_of_polynomial)+3;

	
	if (number_of_data_pairs_cpy<Minimum_required_data_pairs)
	{

		fprintf(stderr,"******************** FUMTU ALERT ******************************\n");
		fprintf(stderr,"*                                                             *\n");
		fprintf(stderr,"* ''line_fit_magic_generate_nth_order_polynomial''must        *\n");
		fprintf(stderr,"*  have >2X order number of data pairs!                       *\n");
		fprintf(stderr,"* You requested a %i order polynomial.\n",us_char_degree_of_polynomial);
		fprintf(stderr,"*                                                             *\n");
		fprintf(stderr,"* You furnished   %i number of data pairs.\n",number_of_data_pairs_cpy);
		fprintf(stderr,"*                                                             *\n");
		fprintf(stderr,"* The minimum required data pairs =%i number of data pairs.\n",Minimum_required_data_pairs);
		fprintf(stderr,"*                                                             *\n");
	    fprintf(stderr,"******************** FUMTU ALERT ******************************\n\n\n");
	    fprintf(stderr,"Tap any key to exit.........\n");
	    getchar();
		
		return-4.00;

	}



	
	
	for (index_i=0;index_i<(2*degree_of_polynomial+1);index_i++)
    {

        X_sigma_sum_array[index_i]=0;
        for (index_j=0;index_j<number_of_data_pairs_cpy;index_j++)
		{
            X_sigma_sum_array[index_i]=X_sigma_sum_array[index_i]+pow(X_value_data_cpy[index_j],index_i); 

		}

	}

	
      // Build the Normal matrix by storing the corresponding coefficients
      // at the right positions except the last column of the matrix
   

	
	
	for (index_i=0;index_i<=degree_of_polynomial;index_i++)
	{
        for (index_j=0;index_j<=degree_of_polynomial;index_j++)
		{
            Augmented_mystery_matrix[index_i][index_j]=X_sigma_sum_array[index_i+index_j];   
		}
	}



	 //consecutive positions will store:
	 // sigma(yi),sigma(xi*yi),sigma(xi^2*yi)...sigma(xi^degree_of_polynomial*yi)
	

	
    for (index_i=0;index_i<degree_of_polynomial+1;index_i++)
    {    
        Y_sigma_sum_array[index_i]=0;
        for (index_j=0;index_j<number_of_data_pairs_cpy;index_j++)
		{
           Y_sigma_sum_array[index_i]=Y_sigma_sum_array[index_i]+pow(X_value_data_cpy[index_j],index_i)*Y_value_data_cpy[index_j]; 
		
		}
	}


  
    //   Build the Normal matrix by storing the corresponding coefficients 
    // at the right positions except the last column of the matrix




    for (index_i=0;index_i<=degree_of_polynomial;index_i++)
	{
        Augmented_mystery_matrix[index_i][degree_of_polynomial+1]=Y_sigma_sum_array[index_i]; 	

	}


	
	
	 // From now Gaussian Elimination starts(can be ignored) to solve the set
	 //of linear equations (Pivotisation)
	



    degree_of_polynomial=degree_of_polynomial+1;               
	

    for (index_i=0;index_i<degree_of_polynomial;index_i++)  
	{

        for (index_k=index_i+1;index_k<degree_of_polynomial;index_k++)
		{

            if (Augmented_mystery_matrix[index_i][index_i]<Augmented_mystery_matrix[index_k][index_i])
			{
                for (index_j=0;index_j<=degree_of_polynomial;index_j++)
                {
                    evanescent_copy=Augmented_mystery_matrix[index_i][index_j];
                    Augmented_mystery_matrix[index_i][index_j]=Augmented_mystery_matrix[index_k][index_j];
                    Augmented_mystery_matrix[index_k][index_j]=evanescent_copy;

                }
			}
		}
	}
				

	
    /*  WARNING!   WARNING!   WARNING!   WARNING!   WARNING!   WARNING! 

     Stability absolutely  requires  a definition of "zero" 
    DO NOT remove any of the "zero" tests I never found root cause.
  
     WARNING!   WARNING!   WARNING!   WARNING!   WARNING!   WARNING! */

	

	
	for (index_i=0;index_i<degree_of_polynomial-1;index_i++)            //loop to perform the gauss elimination
	{

            for (index_k=index_i+1;index_k<degree_of_polynomial;index_k++)
            {
               Single_item_from_mystery_matrix=(double)Augmented_mystery_matrix[index_k][index_i]/Augmented_mystery_matrix[index_i][index_i];


			
                for (index_j=0;index_j<=degree_of_polynomial;index_j++)
				{
                    Augmented_mystery_matrix[index_k][index_j]=((double )Augmented_mystery_matrix[index_k][index_j])-((double )Single_item_from_mystery_matrix*Augmented_mystery_matrix[index_i][index_j]);   

					Numeric_copy_of_long_double = Augmented_mystery_matrix[index_k][index_j];

					if (Numeric_lower_limit> fabs(Numeric_copy_of_long_double))/// DO NOT REMOVE THIS TEST!!!
					 {
                       Augmented_mystery_matrix[index_k][index_j]=0.000;
					 }


				}
			}
   
		
	   }
		
		
		

	

     // loop to perform the gauss elimination


	for (index_i=degree_of_polynomial-1;index_i>=0;index_i--)               
    {  
			
        line_fit_magic_nth_order_polynomial_results[index_i]=Augmented_mystery_matrix[index_i][degree_of_polynomial];   
		


        for (index_j=(index_i+1);index_j<degree_of_polynomial;index_j++)//i+1  Changed here was index_j=(0)
		{
            if (index_j!=index_i)                                       
			{  

				line_fit_magic_nth_order_polynomial_results[index_i]=line_fit_magic_nth_order_polynomial_results[index_i]-Augmented_mystery_matrix[index_i][index_j]*line_fit_magic_nth_order_polynomial_results[index_j];	
			   
			}
		}

        
		line_fit_magic_nth_order_polynomial_results[index_i]=line_fit_magic_nth_order_polynomial_results[index_i]/(Augmented_mystery_matrix[index_i][index_i]);            //now finally divide the rhs by the coefficient of the variable to be calculated
 

	}



    _5th_order_COEFF = line_fit_magic_nth_order_polynomial_results[5];
    _4th_order_COEFF=  line_fit_magic_nth_order_polynomial_results[4];
    _3rd_order_COEFF=  line_fit_magic_nth_order_polynomial_results[3];
    _2nd_order_COEFF=  line_fit_magic_nth_order_polynomial_results[2];
    _1st_order_COEFF=  line_fit_magic_nth_order_polynomial_results[1];
    _0th_order_COEFF=  line_fit_magic_nth_order_polynomial_results[0];


	SUM_of_Y_actual_minus_Y_calculated_squared =0.000;

	for (index_k=0;index_k<number_of_data_pairs_cpy;index_k++)
	{

		
     value_of_X =(double)X_value_data_cpy[index_k];
	 ACTUAL_value_of_Y           =(long double)Y_value_data_cpy[index_k];   

      X_pow_0= pow(value_of_X,0.0000);//Always one (1)!!
      X_pow_1= pow(value_of_X,1.0000);
      X_pow_2= pow(value_of_X,2.0000);
      X_pow_3= pow(value_of_X,3.0000);
      X_pow_4= pow(value_of_X,4.0000);
      X_pow_5= pow(value_of_X,5.0000);


	  Calculated_value_of_Y = (long double) ((X_pow_5*_5th_order_COEFF) + (X_pow_4*_4th_order_COEFF) + (X_pow_3*_3rd_order_COEFF) + (X_pow_2*_2nd_order_COEFF)  + (X_pow_1*_1st_order_COEFF) + (X_pow_0*_0th_order_COEFF));
      
	  Y_actual_minus_Y_calculated = ACTUAL_value_of_Y - Calculated_value_of_Y;
	  
	  Y_actual_minus_Y_calculated_squared = Y_actual_minus_Y_calculated * Y_actual_minus_Y_calculated;
	  
	  SUM_of_Y_actual_minus_Y_calculated_squared = SUM_of_Y_actual_minus_Y_calculated_squared + Y_actual_minus_Y_calculated_squared;
 

	}

	SUM_of_Y_actual_minus_Y_calculated_squared_double = (double) SUM_of_Y_actual_minus_Y_calculated_squared; 
	SUM_of_Y_actual_minus_Y_calculated_ABS = pow(SUM_of_Y_actual_minus_Y_calculated_squared_double,0.5000000);
	Number_of_points_double_format = (double) number_of_data_pairs_cpy;


    average_of_Y_actual_minus_Y_calculated_ABS=SUM_of_Y_actual_minus_Y_calculated_ABS/ Number_of_points_double_format;

	//fprintf(stderr,"average_of_Y_actual_minus_Y_calculated_ABS = %E\n",average_of_Y_actual_minus_Y_calculated_ABS);
   

return average_of_Y_actual_minus_Y_calculated_ABS;// realtive fitness of the returned equation.

};//END line_fit_magic_generate_nth_order_polynomial




#endif



// END of file named "_line_fit_magic_dot_h_"

/*****************  Theoretical Considerations *************************

Comprehension of the fundamental mathematical methodology (linear algebra)
requires that you live in your mother's basement until the age of 35 while
earning a Ph.D. in  the elegance of mathematical philosophy. 

Normal people  may  not comprehend the unga-bunga theoretical drivel
until after a sacrifice of squeaking rats, smelly cockroaches, and a 
few mange infested miniture poodle corpses to the purification flames of 
the Canaanite god associated with child sacrifice, Baal Moloch. May also
need a pentagram on your forehead made of dried chicken dung and ashes.  
***************** _____________________________ *************************/
